*-- Author :    Rainer Mankel   29/05/97
*-- Author :    Peter J. Weyers 24/09/97

      subroutine matfseed(irseg,ift1,ift2,istat)

*     **** seed lepton candidate
      implicit none
      integer irseg,ift1,ift2,istat
c      integer imimp
      integer izf,ift,dom_tc,dom,i,j,dw,dl,sl_tc,sl
      real tfmitoqpt,eta,x,y,tx,ty,x_tc,y_tc,zdl,dz,ex_tc,ey_tc,
     +     cxx,cyy,ctxtx,ctyty,zdet
      real sx,sy,stx,sty
*      parameter (sx=.5,sy=2.,stx=.002,sty=.027) ! mu resolution
*      parameter (sx=.4,sy=1.4,stx=.007,sty=.018) ! mu resolution
      parameter (sx=.17,sy=.92,stx=.012,sty=.020) ! mu resolution

c      parameter(imimp=0) 

      logical init
      character*4 cgesl

#include "arte/Arte.fi"
#include "auto/MIMP.fi"
#include "auto/GEO.fi"
#include "auto/RSEG.fi"

#include "rang/zdomain.fi"
#include "rang/zf.fi"
#include "pris/zmpack.fi"

      data init /.false./
      save init,dom_tc

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/GEO.ff"
#include "auto/RSEG.ff"

**      print *,' matfseed: called for mimp=',imimp

      if (.not.init) then 
         sl_tc = 0
         dom_tc = 0

         do sl=1,iq(jgesl+2)
            write(cgesl,'(a4)') hgesl_name(sl)
            if (cgesl.eq.'TC02') then
               sl_tc = sl
               go to 31
            endif
         enddo
 31      continue
         if (sl_tc.eq.0) then
            print *,' () matfseed: tc superlayer not found'
            stop 'matfseed'
         endif

         do dom=1,n_dm          ! locate TC2 domain
            if (domsl_dm(1,dom).eq.sl_tc) then
               dom_tc = dom
               go to 11
            endif
         enddo
 11      continue
         if (dom_tc.eq.0) then
            print *,' () matfseed: tc domain not found'
            stop 'matfseed'
         endif
      endif
               
      istat = 0
      ift1 = 0
      ift2 = -1

*     **** simulate a seed from muon system

c      zdet = 1600.
c      dz = zdet - fmimp_z(imimp)
c
c      x = fmimp_x(imimp) + dz * fmimp_tx(imimp) ! propagate to mu
c      y = fmimp_y(imimp) + dz * fmimp_ty(imimp)
c      
c      call norran(eta)          ! apply muon system resolution
c      x = x + sx * eta
c
c      call norran(eta)
c      y = y + sy * eta
c
c      call norran(eta)
c      tx = fmimp_tx(imimp) + stx * eta
c
c      call norran(eta)
c      ty = fmimp_ty(imimp) + sty * eta
c
c
c      cxx = sx**2
c      cyy = sy**2
c      ctxtx = stx**2
c      ctyty = sty**2

      zdet = FRSEG_ZF(irseg)

      x = FRSEG_XF(irseg)
      y = FRSEG_YF(irseg)
      
      tx = FRSEG_TXF(irseg)

      ty = FRSEG_TYF(irseg)

      cxx = FRSEG_CVF(matrix_pack(1,1),irseg)
      cyy = FRSEG_CVF(matrix_pack(2,2),irseg)
      ctxtx = FRSEG_CVF(matrix_pack(3,3),irseg)
      ctyty = FRSEG_CVF(matrix_pack(4,4),irseg)


**      print *,' matfseed: x,y,tx,ty=', x,y,tx,ty

**      print *,' dom_tc=',dom_tc,' win1=',win1_dm(dom_tc),
**     +     ' nwin=',nwin_dm(dom_tc)

*     **** plant seed
      do 20 dw=win1_dm(dom_tc),win1_dm(dom_tc)+nwin_dm(dom_tc)-1
     +                           ! search for domain window

         dl = layerlst_dw(1,dw) ! locate last domain layer
         zdl = z_dl(dl)
         x_tc = x + (zdl-zdet) * tx ! extrapolate to domain window
         y_tc = y + (zdl-zdet) * ty
         ex_tc = 3. * sqrt(cxx + ctxtx * (zdl-zdet)**2)
         ey_tc = 3. * sqrt(cyy + ctyty * (zdl-zdet)**2)

#ifdef dmdebug
         print *,' '
         print *,' dl=',dl,' dw=',dw,' xmin/x/xmax=',
     +        xmin_dw(dw),x_tc,xmax_dw(dw)
         print *,' dl=',dl,' dw=',dw,' ymin/y/ymax=',
     +        ymin_dw(dw),y_tc,ymax_dw(dw)
#endif

         if ((x_tc+ex_tc).lt.xmin_dw(dw)) go to 20
         if ((x_tc-ex_tc).gt.xmax_dw(dw)) go to 20
         if ((y_tc+ey_tc).lt.ymin_dw(dw)) go to 20
         if ((y_tc-ey_tc).gt.ymax_dw(dw)) go to 20

         
         if (n_zf.lt.nzfmx) then ! create new entry in zf
            n_zf = n_zf + 1
            izf = n_zf
            xx_zf(1,izf) = x_tc
            xx_zf(2,izf) = y_tc
            xx_zf(3,izf) = tx
            xx_zf(4,izf) = ty

c            xx_zf(5,izf) = tfmitoqpt(imimp)
            xx_zf(5,izf) =sqrt( (1. + tx**2 + ty**2)
     +               / (1. + tx**2) ) * FRSEG_PF(irseg)


      
            cx_zf(1,1,izf) = cxx + ctxtx * (zdl-zdet)**2
            cx_zf(2,2,izf) = cyy + ctyty * (zdl-zdet)**2
            cx_zf(3,3,izf) = ctxtx
            cx_zf(4,4,izf) = ctyty
c            cx_zf(5,5,izf) = 1.7388
            cx_zf(5,5,izf) = sqrt(  (1. + tx**2 + ty**2)
     +                            / (1. + tx**2) ) 
     +                       * FRSEG_CVF(matrix_pack(5,5),irseg)
            cx_zf(1,2,izf) = 0.
            cx_zf(1,3,izf) = (zdl-zdet) * ctxtx
            cx_zf(1,4,izf) = 0.
            cx_zf(2,3,izf) = 0.
            cx_zf(2,4,izf) = (zdl-zdet) * ctyty
            cx_zf(3,4,izf) = 0.
            do i=1,4
               cx_zf(i,5,izf) = 0.
            enddo

            do i=2,5
               do j=1,(i-1)
                  cx_zf(i,j,izf) = cx_zf(j,i,izf)
               enddo
            enddo

            do i=1,dimm
               xm_zf(i,izf) = 0.
               do j=1,dimm
                  cm_zf(i,j,izf) = 999999.
               enddo
               do j=1,4
                  h_zf(i,j,izf) = 0.
               enddo
            enddo

            z_zf(izf)      = zdl
            ch_zf(izf)     = 0.
            cht_zf(izf)    = 0.
            hit_zf(izf)    = 0  ! dummy hit
            nhit_zf(izf)   = 1
            sign_zf(izf)   = 0
            plane_zf(izf)  = 0  ! dummy hit
            domlay_zf(izf) = dl
            prev_zf(izf)   = 0
            prevs_zf(izf)  = 0
            fault_zf(izf)  = 0
            pfault_zf(izf) = 0
c            mc_zf(izf)     = omimp_mtra(imimp)
c            mimp_zf(izf)   = imimp
            mc_zf(izf)     = PRSEG_MTRA(MRSEG_MTRA(irseg))
            mimp_zf(izf)   = 0

            dim_zf(izf)    = 0
            shadow_zf(izf) = 0
            whit_zf(izf)   = 0

            if (nca_ft.lt.ncamx) then ! create new candidate
               nca_ft = nca_ft + 1 
               ift = nca_ft
               if (ift1.eq.0) ift1 = ift
               ift2 = ift
               first_ft(ift) = izf
               last_ft(ift) = izf
               prev_ft(ift) = 0
               gen_ft(ift) = 1
               nhit_ft(ift) = 1
               nfault_ft(ift) = 0
               quality_ft(ift) = 0.
               badhits_ft(ift) = 0
               badsigs_ft(ift) = 0
               stat_ft(ift) = 4
               alive_ft(ift) = .true.
               mature_ft(ift) = .false.

#ifdef dmdebug
               print *,' matfseed: seed planted ift=',ift,
     +              ' izf=',izf,' sector=',secshad_dw(dw),
     +              ' plshad=',plshad_dw(dw)

               print *,'     x=',sngl(xx_zf(1,izf)),
     +              '  ex=',sngl(dsqrt(cx_zf(1,1,izf))),
     +              ' mc=',fmimp_x(imimp) 
     +              + (zdl-fmimp_z(imimp)) * fmimp_tx(imimp)
               print *,'    tx=',sngl(xx_zf(3,izf)),
     +              ' etx=',sngl(dsqrt(cx_zf(3,3,izf))),
     +              ' mc=',fmimp_tx(imimp) 

               print *,' direct z  -- x comparison:'

               print *,fmimp_z(imimp),fmimp_x(imimp),' mimp '
               print *,zdet,          x,             ' det '
               print *,zdl,        x_tc,             ' tc/dl'  
#endif

            else
               print *,' () matfseed: overflowing nca_ft=',nca_ft
               istat = -10
            endif
         else
            print *,' () matfseed: overflowing n_zf=',n_zf
            istat = -10
         endif

 20   continue

 999  end
