*-- Author :    Rainer Mankel   29/05/97

      subroutine matfupstr(istat)

*     **** upstream propagation of lepton candidate
      implicit none
#include "rang/zfmode.fi"
#include "rang/zfpar.fi"
#include "rang/zf.fi"
#include "rang/zdomain.fi"
#include "rang/ztripl.fi"
#include "rang/zcut.fi"
#include "pris/zpstat.fi"
#include "arte/ArteFlag.fi"
#include "arte/Arte.fi"
#include "auto/MIMP.fi"
#include "auto/RSEG.fi"
#include "RSEG_cmp.fi"

      integer maxlep
      parameter (maxlep=10)

      integer ift,iilep
      integer iseg
c      integer imimp
      integer ift1,ift2,nca_x,direction,
     +      begin_store,istat,nca_prep,lep(maxlep),nlep
      logical init

      save init
      data init /.false./

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/RSEG.ff"

******************************************************************
*
*     Organization of storage:
*
*           1                  |
*           .                  | x candidates
*           .                  |
*         nca_x                |
*           .                   |
*           .                   | y candidates, 3d candidates
*         nca_y                 |
*           .                    |
*           .                    | magnet seeds
*         nca_prep               |
*           .                     |
*           .                     | magnet candidates
*           .                     |
*
******************************************************************

      l_diag = .false.
      diag_level = 0

      if (.not.l_rinit) call tfrinit() ! restricted init

      l_term = .false.
      lremzc = .false.

*     **** do the work
      if (.not.init) then
         call dmmain()          ! set up domain structure
         init = .true.
      endif

      call dmhit(istat)         ! set domain hit buffer
      if (istat.le.-100) go to 999

      call tfref()   ! prepare reference track information

      call tuloclep(lep,nlep,maxlep)

*      l_diag = .true.
*      diag_level = 6

c      do 10 iilep=1,nlep        ! loop over lepton candidates
      do 10 iseg=1,NRSEG()

         if(IRSEG_CMP(iseg).NE.RSEGc_ecal.AND.
     $      IRSEG_CMP(iseg).NE.RSEGc_muon) THEN
            write(*,*) ' matfupstr: wrong IRSEG_CMP(',
     $           iseg,')=',IRSEG_CMP(iseg)
            goto 10
         ENDIF
c         call tflocmimp(lep(iilep),imimp) ! locate last mimp
c
c         if (fmimp_z(imimp).lt.1300.) go to 10

         call tfclr()           ! clear p.r. buffer
         begin_ft = 1
         call matfseed(iseg,ift1,ift2,istat) ! seed
         print *,' matfupstr: tflepseed returns ift1,ift2,istat=',
     +        ift1,ift2,istat

         direction = -1

         nca_prep = ift2        ! store new endpointer

         l_2dx = .false.
         l_2dy = .false.
         l_mag = .true.
         begin_ft = nca_prep + 1
         istat = 0
         call tfpropm(ift1,-1,istat)
         print *,' matfupstr: tfpropm returns istat=',istat
         if (istat.ge.0) then
         elseif (istat.le.-100) then
            go to 999           ! no further propagation
         elseif (istat.le.-1) then
            go to 10            ! terminate branch
         endif

         if (diag_level.ge.2) then
            call tfl()
            print *,' after tfpropm,before tfbest'
            call tfwait()
         endif
         begin_ft = nca_prep + 1
         call tfbest()
         if (diag_level.ge.3) then
            call tfl()
            print *,' after tfbest'
            call tfwait()
         endif

*        **** store loop
 9       continue
         if (rlevel_zfpar.eq.1) then
            begin_store = 1
         elseif (rlevel_zfpar.eq.2) then
            begin_store = nca_x + 1
         else
            begin_store = nca_prep + 1
         endif
         do 40 ift=begin_store,nca_ft
            if (alive_ft(ift)) then
               if (quality_ft(ift).lt.6.) go to 40
               call tfstor(ift)
               if (l_diag) call tfwait()
            endif
 40      continue

 10   continue                  ! lepton candidates

**      if (rlevel_zfpar.le.2) then
         call tfstat()
**      else
**         call tfstam()
**      endif

 999  end
