
      SUBROUTINE MA98FISVDS(irseg_svd,irseg_fix,irseg_last)
      IMPLICIT NONE

************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Find SVD Segment for given (e.g. OTR) segment.
*                  (This is the core of the match98 package)
*
      INTEGER irseg_svd  ! In     ir of previous found segment, 0 = start
                         ! Out    ir of found RSEG, 0 = no more
      INTEGER irseg_fix  ! In     ir of segment to match to (expecting coord.
                         !        at Target)      
      INTEGER irseg_last ! In     Last RSEG row number to be considered as
                         !        possible match - NRSEG() is not good for
                         !        this, as is increased after a match is found
*
*
************************************************************************

#include "arte/Arte.fi"
#include "auto/RSEG.fi"
#include "match98.fi"

c ----------------------
      INTEGER lastirseg_svd
      INTEGER lastirseg_fix
      REAL    svdseg_ze
      REAL    tx_fix,ty_fix
      REAL    bx_fix,by_fix
      REAL    x_fix,y_fix

c ----------------------
      SAVE lastirseg_fix,lastirseg_svd
      DATA lastirseg_fix / 0 /
      DATA lastirseg_svd / 0 /

#include "arte/Arte.ff"
#include "auto/RSEG.ff"

************************************************************************

      IF(ma_cuts_set.NE.ma_gic_true) THEN
         WRITE(*,*) ' ma98fisvds: First time cuts are set'
         ma_x_cut=0.2
         ma_y_cut=0.25
         ma_tx_cut=0.0015
         ma_ty_cut=0.002
         ma_x_ofs=-1.
         ma_y_ofs=-1.
         ma_tx_ofs=-1.
         ma_ty_ofs=-1.
         ma_cuts_set=ma_gic_true
      ENDIF
         
      IF(ma_verblvl.GE.20) WRITE(*,*) 'ma98fisvds:',
     $     '(1) lastirseg_fix=',lastirseg_fix,' irseg_fix=',irseg_fix,
     $     ' irseg_svd=',irseg_svd

      IF(lastirseg_fix.NE.irseg_fix) THEN
         irseg_svd=0
         lastirseg_fix=irseg_fix
      ENDIF

      irseg_svd=irseg_svd+1

      IF(ma_verblvl.GE.20) WRITE(*,*) 'ma98fisvds:',
     $     '(2) lastirseg_fix=',lastirseg_fix,' irseg_fix=',irseg_fix,
     $     ' irseg_svd=',irseg_svd

      DO WHILE(irseg_svd.LE.irseg_last)
         IF(IAND(RSEGc_vxd,IRSEG_CMP(irseg_svd)).NE.0) THEN
            svdseg_ze=FRSEG_ZE(irseg_svd)

            tx_fix=FRSEG_TXF(irseg_fix)
            bx_fix=FRSEG_XF(irseg_fix)-(tx_fix*FRSEG_ZF(irseg_fix))

            ty_fix=FRSEG_TYF(irseg_fix)
            by_fix=FRSEG_YF(irseg_fix)-(ty_fix*FRSEG_ZF(irseg_fix))

            x_fix=tx_fix*svdseg_ze+bx_fix
            y_fix=ty_fix*svdseg_ze+by_fix

            IF(ma_x_ofs.GT.-0.5)  x_fix =x_fix -ma_x_ofs
            IF(ma_y_ofs.GT.-0.5)  y_fix =y_fix -ma_y_ofs
            IF(ma_tx_ofs.GT.-0.5) tx_fix=tx_fix-ma_tx_ofs
            IF(ma_ty_ofs.GT.-0.5) ty_fix=ty_fix-ma_ty_ofs
            
            IF(ABS(x_fix  - FRSEG_XE(irseg_svd) ).LE.ma_x_cut.AND.
     $         ABS(y_fix  - FRSEG_YE(irseg_svd) ).LE.ma_y_cut.AND.
     $         ABS(tx_fix - FRSEG_TXE(irseg_svd)).LE.ma_tx_cut.AND.
     $         ABS(ty_fix - FRSEG_TYE(irseg_svd)).LE.ma_ty_cut) THEN
               RETURN

            ENDIF
         ENDIF
         irseg_svd=irseg_svd+1
      ENDDO
      irseg_svd=0
      lastirseg_svd=0

      RETURN
      END

************************************************************************
* End of MA98FISVDS
************************************************************************



