      SUBROUTINE maecaldaughters(zlow,zhigh)
      
      IMPLICIT NONE
************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Used internally by the match98 package to collect      
*                  MC daughters of the particles found in the MC information
*                  for the ECAL
      REAL zlow,zhigh ! zrange in where the produced daughters are collected
*
************************************************************************

#include "arte/Arte.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/MVER.fi"
#include "auto/MVEX.fi"
#include "maecaldau.fi"

      INTEGER imtra,indx,dau_mtra

#include "arte/Arte.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/MVER.ff"
#include "auto/MVEX.ff"

      imtra=mtra_stack(pntr_l)
c      WRITE(*,*) ' maecaldaughters: search daut''s of ',imtra
c      WRITE(*,*),' l/h/st ',pntr_l,pntr_h,mtra_stack

      IF(imtra.EQ.0.OR.pntr_l.GE.pntr_max) THEN
         pntr_h=pntr_l
            WRITE(*,*) ' maecaldaughters: end reached, pntr_l=',pntr_l
         RETURN
      ENDIF

      IF(pntr_h.LE.pntr_max) THEN
         indx=PMTRX_ETRA(imtra)
         DO WHILE(indx.NE.0)
            dau_mtra=MMTRX_ETRA(indx)
            IF(FMVER_Z(OMTRX_BVER(dau_mtra)).GT.zlow.AND.
     $         FMVER_Z(OMTRX_BVER(dau_mtra)).LT.zhigh)THEN
               IF(pntr_h.LE.pntr_max) THEN
                  mtra_stack(pntr_h)=dau_mtra
                  pntr_h=pntr_h+1
c                  WRITE(*,*),' l/h/st ',
c     $                 pntr_l,pntr_h,mtra_stack
               ELSE
                  WRITE (*,*) ' maecaldaughters: mtra_stack full !!'
               ENDIF
            ENDIF
            indx=XMTRX_ETRA(indx)
         ENDDO
      ELSE
         WRITE (*,*) ' maecaldaughters: mtra_stack full !!!'
      ENDIF
      IF(pntr_h.LE.pntr_max) THEN
         mtra_stack(pntr_h)=0
      ENDIF
      pntr_l=pntr_l+1
      END






