
      SUBROUTINE maecalseg(z,x,dx,E,dE,imtra,irseg_new)

      IMPLICIT NONE
************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Create a RSEG Table row with segment length 0 for a
*                  Spacepoint with direction & energy information
*
      REAL    z          ! in     guess ! :-)
      REAL    x(5),dx(5) ! in/out x,y,tx,ty,q/p & Errors
                         !        expects x(1..4) to be already set, will set
                         !        x(5) from E
      REAL    E,dE       ! in     Measured Energy + Error, sign of E indicates
                         !        charge of e, to be used in RSEG_PF/_PE (q/p)
      INTEGER imtra      ! in     Needed for Rel. MTRA - RSEG
                         !        Will be ignored if zero
      INTEGER irseg_new  ! out    row number of new rseg
*
**************************************************************************

#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/RSEG.fi"
#include "auto/RHIT.fi"
#include "auto/TOPP.fi"
#include "auto/MTRA.fi"
#include "match98.fi"
#include "pris/zmpack.fi"

      INTEGER i,j
      
      REAL    mass,p
C ----

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/RSEG.ff"
#include "auto/RHIT.ff"
#include "auto/TOPP.ff"
#include "auto/MTRA.ff"

      IF(ma_verblvl.GE.15) WRITE(*,*) ' maecalseg: imtra=',imtra

c ----- create new RSEG
      IF(ma_ecal_mode.EQ.ma_ecal_pseudo.AND.imtra.NE.0) THEN
         mass=FTOPP_MASS(OMTRA_TOPP(imtra))
      ELSE
         mass=FTOPP_MASS(code_eplus)
      ENDIF

      IF((E**2-mass**2).GT.0) THEN
         p=SQRT(E**2-mass**2)
         x(5)=SIGN(1./p,E)
         dx(5)=ABS(E*dE/(p**3))
      ELSE
         IF(ma_verblvl.GE.5) WRITE(*,*) ' maecalseg: |p| < 0 !!'
         x(5)=SIGN(100000000.,E)
         dx(5)=100000000.
         IF(ma_verblvl.GE.5) WRITE(*,*) 
     $        '          q/p:=',x(5),'+/-',dx(5)
      ENDIF

c --------- Fill RSEG row entries 
   
      CALL MMBOOK(JRSEG,1)      ! increase row counter
      irseg_new = NRSEG()

      Q(QRSEG_ZF_L())  = z
      Q(QRSEG_XF_L())  = x(1) 
      Q(QRSEG_YF_L())  = x(2) 
      Q(QRSEG_TXF_L()) = x(3) 
      Q(QRSEG_TYF_L()) = x(4)
      Q(QRSEG_PF_L())  = x(5)

      Q(QRSEG_TIME_L())=  0 ! ?????????????
      Q(QRSEG_DTIM_L())=  0 ! ?????????????

      Q(QRSEG_ZE_L())  =  FRSEG_ZF(irseg_new)
      Q(QRSEG_XE_L())  =  FRSEG_XF(irseg_new)
      Q(QRSEG_YE_L())  =  FRSEG_YF(irseg_new)
      Q(QRSEG_TXE_L()) =  FRSEG_TXF(irseg_new)
      Q(QRSEG_TYE_L()) =  FRSEG_TYF(irseg_new)
      Q(QRSEG_PE_L())  =  FRSEG_PF(irseg_new) 

      DO i=1,5
         DO j=1,5
            IF(i.EQ.j) THEN
               Q(QRSEG_CVE_L(matrix_pack(i,j)))= dx(i)**2
               Q(QRSEG_CVF_L(matrix_pack(i,j)))= dx(i)**2
            ELSE
               Q(QRSEG_CVE_L(matrix_pack(i,j)))= 0
               Q(QRSEG_CVF_L(matrix_pack(i,j)))= 0
            ENDIF
         ENDDO               !
      ENDDO                  !

      IF(imtra.NE.0) CALL MMBREL(JRSMT,irseg_new,imtra)

      Q(QRSEG_CHI_L()) = 0 ! ? 
      IQ(IQRSEG_FIT_L()) = 0 ! Without Momentum information
      IQ(IQRSEG_CMP_L()) = 0 ! its only a dummy segment
   
      END
**************************************************************************
*  End of maecalseg
**************************************************************************





