      LOGICAL FUNCTION maecalswitch(xyz,dxyz,E,dE,imtra,imimp)
      
      IMPLICIT NONE

************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Call the Ecal Simulation according to the choice made 
*                  with the KUIP command match98/ecalmode.
      
      REAL xyz(3),dxyz(3) ! out   Ecal hit coordinates and errors
      REAL E,dE           ! out   "Measured" energy and errors
      INTEGER imtra       ! in    Row of MTRA table of particle, for which
                          !       an Ecal hit shall be simulated
      INTEGER imimp       ! out   Last MIMP of particle in front of the ECAL
*
************************************************************************

#define MAECALSWITCH_FUNC_DEF
#include "match98.fi"

      IF(ma_ecal_mode.EQ.0) THEN
         WRITE (*,*) 'Ecal Mode has not been set yet!'
         WRITE (*,*) 'Please set a mode!'
         CALL MAKUECALSWITCH()
      ENDIF
      IF(ma_ecal_mode.EQ.ma_ecal_mc) THEN
         maecalswitch=magetecal(xyz,dxyz,E,dE,imtra,imimp)
      ELSEIF(ma_ecal_mode.EQ.ma_ecal_pseudo) THEN
         maecalswitch=mapseudoecal(xyz,dxyz,E,dE,imtra,imimp)
      ELSE
         WRITE (*,*) ' !!! No proper ECALMODE selected !!!'
      ENDIF

      IF(ma_verblvl.GE.20) WRITE(*,*) ' maecalswitch:',
     $     maecalswitch,xyz,dxyz,E,dE,imtra,imimp

      RETURN
      END

