      SUBROUTINE MAESMEAR(E,dE)

      IMPLICIT NONE

************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Apply an Error to a given Energy value
*                  The Error is a combination of the calibration Error set by
*                  the KUIP command match98/dE and the sampling Error given
*                  by dE


      REAL E   ! In  Energy to be smeared 
               ! Out "Measured" (i.e. smeared) energy value
      REAL dE  ! In  sampling Error Width
               ! Out total Error width

*
************************************************************************

#include "match98.fi"

      REAL E_orig,random1,random2

      IF(ma_verblvl.GE.15) WRITE(*,*) ' maEsmear:',
     $  '(input: ) E=',E,'+/-',SQRT(ABS(E))*dE,'+/-',ma_dE

      CALL NORRAN(random1)
      CALL NORRAN(random2)

      E_orig=E

      E=E_orig+random1*SQRT(ABS(E_orig))*dE+random2*ma_dE

      dE=SQRT((SQRT(ABS(E_orig))*dE)**2+ma_dE**2)

      CALL HF1(mahb_erdiff,(E_orig-E)/E_orig,1.)

      IF(ma_verblvl.GE.15) WRITE(*,*) ' maEsmear:',
     $     '(output:) E=',E,' +/- ',dE

      RETURN
      END
***************************************
