      SUBROUTINE MAFILEPSEG(rsegmax,rsegs,rsegc,cmp)

      IMPLICIT NONE

******************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Find (Reconstructed) Lepton Segments
      
      INTEGER rsegmax        ! In      Length of Arrays
      INTEGER rsegs(rsegmax) ! Out     List of found segments
      INTEGER rsegc          ! In/Out  Number of already listed segments
      INTEGER cmp            ! In      Bitpattern to match IRSEG_CMP
*
******************************************************************************

#include "arte/Arte.fi"
#include "auto/RSEG.fi"
#include "auto/RTRX.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "mapstat.fi"
#include "match98.fi"

      INTEGER i
      INTEGER indx
      INTEGER mtra_code
      INTEGER mtra_ir
      INTEGER rseg_ir
      INTEGER ngold
      INTEGER imtra_lepton
      INTEGER lepgol

#include "arte/Arte.ff"
#include "auto/RSEG.ff"
#include "auto/RTRX.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"


************************************************************************

      IF(ma_verblvl.GE.19) WRITE(*,*) ' mafilepseg:',
     $  ' called with rsegmax=',rsegmax,'rsegc=',rsegc,'cmp=',cmp

      IF(ma_verblvl.GE.19) WRITE(*,*) ' mafilepseg:',
     $  ' ma_lep_mode=',ma_lep_mode

      IF(ma_lep_mode.EQ.ma_lep_any)THEN ! Just go through all segments 
                                         ! and select MC leptons
         IF(ma_verblvl.GE.9)
     $        WRITE(*,*) ' mafilepseg: find any MC lepton mode'
         DO rseg_ir=1,NRSEG()
c           Search for MC Leptons
            indx     = PRSEG_MTRA(rseg_ir)
c            WRITE(*,*) ' mafilepseg: checking',rseg_ir
            DO WHILE(indx.NE.0)
c               WRITE(*,*) ' mafilepseg: index ',indx
               imtra_lepton = MRSEG_MTRA(indx)
               mtra_code  = OMTRA_TOPP(imtra_lepton)
               IF(mtra_code.EQ.code_muplus.OR.
     $            mtra_code.EQ.code_muminus.OR.
     $            mtra_code.EQ.code_eplus.OR.
     $            mtra_code.EQ.code_eminus)THEN
                  IF(ma_verblvl.GE.8)
     $                 WRITE(*,*) ' mafilepseg: MTRA/RSEG: ',
     $                 imtra_lepton,rseg_ir
                  IF(cmp.EQ.IRSEG_CMP(rseg_ir)) THEN
                     rsegc=rsegc+1
                     rsegs(rsegc)=rseg_ir
                     IF(ma_verblvl.GE.8)
     $                    WRITE(*,*) '       ... taken'
                     IF(rsegc.EQ.rsegmax) GOTO 900 ! rsegmax reached
                  ELSE
                     IF(ma_verblvl.GE.8)
     $                    WRITE(*,*) '       ... not taken (wrong cmp)'
                  ENDIF
               ENDIF
               indx=XRSEG_MTRA(indx)
            ENDDO
         ENDDO
      ELSE
         IF(ma_verblvl.GE.9)
     $        WRITE(*,*) ' mafilepseg: golden/JPsi/Ups*/Bsem event mode'
         CALL MATULOCLEP()

         DO ngold=1,ma_pstat_n
            DO lepgol=pstat_lminus,pstat_lplus,pstat_lplus-pstat_lminus
              mtra_ir=ma_pstat(lepgol,ngold)
              IF(ma_verblvl.GE.9)
     $           WRITE(*,*) ' mafilepseg: checking  lepgol,ngold=',
     $                        lepgol,ngold
              IF(mtra_ir.NE.0) THEN 
                 indx     = PMTRX_RSEG(mtra_ir)
                 IF(indx.EQ.0.AND.ma_verblvl.GE.4)
     $                WRITE(*,*) ' mafilepseg: PMTRX_RSEG=0'
                 DO WHILE(indx.NE.0)
                  rseg_ir=MMTRX_RSEG(indx)
                  IF(ma_verblvl.GE.8)
     $                 WRITE(*,*) ' mafilepseg: MTRA/RSEG(ngold): ',
     $                 mtra_ir,rseg_ir,'(',ngold,')'
                  IF(cmp.EQ.IRSEG_CMP(rseg_ir))THEN
                     rsegc=rsegc+1
                     rsegs(rsegc)=rseg_ir
                     IF(ma_verblvl.GE.8)
     $                    WRITE(*,*) '       ... taken'
                     IF(rsegc.EQ.rsegmax) GOTO  900 ! rsegmax reached
                  ELSE
                     IF(ma_verblvl.GE.8)
     $                    WRITE(*,*) '       ... not taken (wrong cmp)'
                  ENDIF
                  indx=XMTRX_RSEG(indx)
                 ENDDO
              ELSE
                 IF(ma_verblvl.GE.4)
     $              WRITE(*,*) ' mafilepseg: imtra=0 for lepgol,ngold=',
     $                        lepgol,ngold
              ENDIF
            ENDDO

         ENDDO
      ENDIF
      GOTO 999

 900  CONTINUE
      IF(ma_verblvl.GE.4)
     $        WRITE(*,*) ' mafilepseg: rsegmax',rsegmax,' reached'

 999  CONTINUE

      IF(rsegc.EQ.0) THEN
         IF(ma_verblvl.GE.10) WRITE(*,*) ' mafilepseg:',
     $  ' returning with rsegc=',rsegc
      ELSE
         IF(ma_verblvl.GE.19) WRITE(*,*) ' mafilepseg:',
     $  ' returning with rsegs=',(rsegs(i),i=1,rsegc)
      ENDIF
      RETURN

      END

************************************************************************
* End of MAFILEPSEG
************************************************************************






