      LOGICAL FUNCTION magetecal(xyz,dxyz,E_ret,dE,imtra,mimp_maxz)

      IMPLICIT NONE

************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Ecal Simulation
      
      REAL xyz(3),dxyz(3) ! out   Ecal hit coordinates and errors
      REAL E_ret,dE       ! out   "Measured" energy and errors
      INTEGER imtra       ! in    Row of MTRA table of particle, for which
                          !       an Ecal hit shall be simulated
      INTEGER mimp_maxz   ! out   Last MIMP of particle in front of the ECAL
*
************************************************************************

#include "arte/Arte.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/MIMP.fi"
#include "auto/TOPP.fi"
#include "auto/MCAL.fi"
#include "auto/GCAL.fi"
#include "maecaldau.fi"
#define MAGETECAL_FUNC_DEF
#include "match98.fi"

c 
c       INTEGER max_cells,n_cells,i
c       PARAMETER (max_cells=100)
c       REAL x(max_cells),y(max_cells),z(max_cells),Ex(max_cells),
c      $     mtra(max_cells)
c       REAL x_sum,y_sum,z_sum,E_sum
c 


      REAL E_mtra
      REAL E_mc
      REAL ecal_z
      PARAMETER(ecal_z=1331.)

      INTEGER imcal,igcal,indx,ix,iy,cell,nbl,stack_ptr,mtra_dau
 
      INTEGER imimp,mimp_E,i
      REAL mc_q,z_max,z_min,random
      LOGICAL if_ecal_hit

#include "arte/Arte.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/MIMP.ff"
#include "auto/TOPP.ff"
#include "auto/MCAL.ff"
#include "auto/GCAL.ff"


      IF(ma_verblvl.GE.15) WRITE(*,*) ' magetecal: MTRA=',imtra


      pntr_l=1
      pntr_h=pntr_l+1
      mtra_stack(pntr_l)=imtra
      mtra_stack(pntr_h)=0
 
      DO WHILE(pntr_l.LT.pntr_h)
c         IF(ma_verblvl.GE.10) WRITE(*,*) ' magetecal: mtra_stack(',pntr_l,')=',
c     $        mtra_stack(pntr_l)
c         CALL maecaldaughters(1330.,1480.)
         CALL maecaldaughters(700.,1600.)
      ENDDO

      IF(PMTRX_MCAL(imtra).NE.0) THEN
         if_ecal_hit=.TRUE.
      ELSE
         if_ecal_hit=.FALSE.
         DO stack_ptr=1,pntr_h-1
            IF(PMTRX_MCAL(mtra_stack(stack_ptr)).NE.0) THEN
               if_ecal_hit=.TRUE.
            ENDIF
         ENDDO
      ENDIF

      E_mc=0

      IF(if_ecal_hit) THEN
         mimp_maxz=0
         z_max=0
         indx=0
         DO WHILE(maslcmimp_mtra(imimp,indx,imtra))
            IF(z_max.LT.FMIMP_Z(imimp).AND.
     $           FMIMP_Z(imimp).LE.1340.) THEN
               z_max=FMIMP_Z(imimp)
               mimp_maxz=imimp
            ENDIF
         ENDDO
         IF(mimp_maxz.NE.0) THEN
            IF(ma_verblvl.GE.16) WRITE(*,*) ' magetecal:',
     $           ' mimp taken:',mimp_maxz,
     $           ', z=',FMIMP_Z(mimp_maxz)
   
            xyz(1)=FMIMP_X(mimp_maxz)+
     $             (ecal_z-FMIMP_Z(mimp_maxz))*FMIMP_TX(mimp_maxz)
            xyz(2)=FMIMP_Y(mimp_maxz)+
     $             (ecal_z-FMIMP_Z(mimp_maxz))*FMIMP_TY(mimp_maxz)
            xyz(3)=ecal_z
            dxyz(3)=0.1

            indx=PMTRX_MCAL(imtra)
            IF(indx.NE.0) THEN
              imcal=MMTRX_MCAL(indx)
              igcal= IMCAL_GCAL(imcal)/100
              nbl = IGCAL_NCL(igcal)
c ---  Spacial resolutions taken from the TDR p. 314: ---
              IF(nbl.EQ.1)THEN
                 dxyz(1)=1.7
                 dxyz(2)=1.5
                 dE=0.17
              ELSEIF(nbl.EQ.2)THEN
                 dxyz(1)=0.82
                 dxyz(2)=0.65
                 dE=0.17
              ELSEIF(nbl.EQ.5)THEN
                 dxyz(1)=0.33
                 dxyz(2)=0.25
                 dE=0.095
              ELSE
                IF(ma_verblvl.GE.4) WRITE(*,*) ' magetecal:',
     $                ' funny row length:',
     $                indx,imcal,igcal,nbl
                dxyz(1)=2
                dxyz(2)=2
                dE=0.1
              ENDIF
              dE=0
              DO stack_ptr=1,pntr_h-1
                 indx=PMTRX_MCAL(mtra_stack(stack_ptr))
                 DO WHILE(indx.NE.0)
                    imcal=MMTRX_MCAL(indx)
                    igcal= IMCAL_GCAL(imcal)/100
                    nbl = IGCAL_NCL(igcal)
                    IF(nbl.EQ.1)THEN
                       dE=SQRT(dE**2+0.17**2*(6.7*FMCAL_DE(imcal)))
                       E_mc=E_mc+FMCAL_DE(imcal)*ma_e1samp
                    ELSEIF(nbl.EQ.2)THEN
                       dE=SQRT(dE**2+0.17**2*(6.7*FMCAL_DE(imcal)))
                       E_mc=E_mc+FMCAL_DE(imcal)*ma_e2samp
                    ELSEIF(nbl.EQ.5)THEN
                       dE=SQRT(dE**2+0.095**2*(30.*FMCAL_DE(imcal)))
                       E_mc=E_mc+FMCAL_DE(imcal)*ma_e5samp
                    ELSE
                       IF(ma_verblvl.GE.3) WRITE(*,*) ' magetecal:',
     $                      ' funny row length:',
     $                      indx,imcal,igcal,nbl
                       dE=1
                       ma_funrl_cnt=ma_funrl_cnt+1
                    ENDIF
                    indx=XMTRX_MCAL(indx)
                 ENDDO
              ENDDO
              dE=dE/SQRT(E_mc)
            ELSE
               dxyz(1)=1.7
               dxyz(2)=1.5
               dE=0.17
            ENDIF
            mc_q=ITOPP_CHRG(OMTRA_TOPP(imtra))/3.

            mimp_E=0
            z_min=1340.
            indx=0

            DO WHILE(maslcmimp_mtra(imimp,indx,imtra))
               IF(z_min.GT.FMIMP_Z(imimp).AND.
     $              FMIMP_Z(imimp).GE.700.) THEN
                  z_min=FMIMP_Z(imimp)
                  mimp_E=imimp
               ENDIF
            ENDDO

            IF(mimp_E.EQ.0) mimp_E=mimp_maxz

            CALL HF1(mahb_z,FMIMP_Z(mimp_E),1.)

            E_mtra=SIGN(SQRT(FTOPP_MASS(OMTRA_TOPP(imtra))**2+
     $                FMIMP_P(mimp_E)**2),
     $                          mc_q)
            IF(ma_verblvl.GE.20) WRITE(*,*)
     $           ' magetecal: E_mc=',E_mc,' , E_mtra=',E_mtra
            IF(ma_verblvl.GE.20) WRITE(*,*)
     $           ' magetecal: E_mc/E_mtra=',E_mc/E_mtra,
     $           ' ,E_mtra-E_mc=',E_mtra-E_mc
            magetecal=.TRUE.
c            CALL HF1(mahb_z,xyz(3),1.)
            IF(E_mtra.NE.0) CALL HF1(mahb_ediff,E_mc-ABS(E_mtra),1.)
            E_ret=E_mc
            CALL maEsmear(E_ret,dE)
            DO i=1,2
               CALL NORRAN(random)
               xyz(i)=xyz(i)+dxyz(i)*random
            ENDDO
            RETURN
         ENDIF
      ELSE
            IF(ma_verblvl.GE.5) WRITE(*,*) ' magetecal:',
     $        ' PMTRX_MCAL(',imtra,') = 0 (and daughters)'
      ENDIF
      magetecal=.FALSE.
      RETURN
      END
