      SUBROUTINE MAIFRSEGMTRA(irseg,imtra,retval)
      
      IMPLICIT NONE

************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Check whether a given RSEG row number corresponds to
*                  a MTRA  given also by rownumber
*                                                                         

      INTEGER irseg       ! In    ir of RSEG to be tested
      INTEGER imtra       ! In    ir of mtra to match to
      LOGICAL retval      ! Out   .TRUE. when RSEG matches

*
************************************************************************

#include "arte/Arte.fi"
#include "auto/RSEG.fi"
#include "auto/RTRX.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "match98.fi"

c ----------------------
      INTEGER indx,imtra_seg

#include "arte/Arte.ff"
#include "auto/RSEG.ff"
#include "auto/RTRX.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"


************************************************************************
      indx     = PRSEG_MTRA(irseg)
      DO WHILE(indx.NE.0)
         imtra_seg = MRSEG_MTRA(indx)
         IF(imtra_seg.EQ.imtra)THEN
            retval=.TRUE.
            GOTO 900
         ENDIF
         indx=XRSEG_MTRA(indx)
      ENDDO
      retval=.FALSE.
      GOTO 900
 900  CONTINUE
      IF(ma_verblvl.GE.15) WRITE (*,*) ' maifrsegmtra:',
     $     ' match of RSEG',irseg,' for MTRA',imtra,' is',retval
      RETURN
      END
************************************************************************
* End of MAIFRSEGMTRA
************************************************************************





