      SUBROUTINE makudetmode
************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Invoked by KUIP to interactivly choose which Lepton
*                  detector is used by the match98 package
*
************************************************************************
      IMPLICIT NONE

      CHARACTER*4 det
      INTEGER nch

#include "match98.fi"

      CALL KUGETC(det,nch)
      
      IF(det.EQ.'E'.OR.det.EQ.'ECAL') THEN
         ma_det_mode=ma_det_ecal
         ma_det_mode_set=ma_gic_true
      ELSEIF(det.EQ.'M'.OR.det.EQ.'MUON') THEN
         ma_det_mode=ma_det_muon
         ma_det_mode_set=ma_gic_true
      ELSEIF(det.EQ.'B'.OR.det.EQ.'BOTH') THEN
         ma_det_mode=IOR(ma_det_muon,ma_det_ecal)
         ma_det_mode_set=ma_gic_true
      ELSEIF(det.EQ.'N'.OR.det.EQ.'NONE') THEN
         ma_det_mode=0
         ma_det_mode_set=ma_gic_true
      ENDIF

      IF(IAND(ma_det_mode,ma_det_ecal).NE.0)
     $     WRITE(*,*) ' Lepton Detector ECAL used'
      IF(IAND(ma_det_mode,ma_det_muon).NE.0)
     $     WRITE(*,*) ' Lepton Detector MUON used'
      IF(ma_det_mode_set.NE.ma_gic_true) THEN 
         WRITE(*,*) ' Lepton Detector not set !!!'
      ELSEIF(ma_det_mode.EQ.0) THEN
         WRITE(*,*) ' No Lepton Detector selected'
      ENDIF

      END
      
