      SUBROUTINE MAKUESAMP()
************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Called by KUIP to interactivly set the sampling factors
*                  for the ECAL simulation used in magetecal().
*
************************************************************************
      IMPLICIT NONE

      REAL e1samp,e2samp,e5samp

#include "match98.fi"

      CALL KUGETR(e1samp)
      CALL KUGETR(e2samp)
      CALL KUGETR(e5samp)

      IF(ma_esamp_set.NE.ma_gic_true) THEN
         WRITE(*,*) 'First time factors are set'
         ma_e1samp=6.7
         ma_e2samp=6.7
         ma_e5samp=30.0
         ma_esamp_set=ma_gic_true
      ENDIF

      IF(e1samp.GE.-.5) ma_e1samp=e1samp
      IF(e2samp.GE.-.5) ma_e2samp=e2samp
      IF(e5samp.GE.-.5) ma_e5samp=e5samp


      WRITE(*,*) 'Selected Sampling Factors:'
      WRITE(*,*) ' e1samp=',ma_e1samp
      WRITE(*,*) ' e2samp=',ma_e2samp
      WRITE(*,*) ' e5samp=',ma_e5samp
      END
      
