      SUBROUTINE makuleptonmode
************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Called by KUIP to interacivly choose leptons of which kind
*                  of reaction shall  be collected by matuloclep().
*
************************************************************************
      IMPLICIT NONE

      CHARACTER*8 lepmode
      INTEGER nch

#include "match98.fi"

      CALL KUGETC(lepmode,nch)
      
      IF(lepmode.EQ.'GOLD') THEN
         ma_lep_mode=ma_lep_golden
      ELSEIF(lepmode.EQ.'JPSI') THEN
         ma_lep_mode=ma_lep_JPsi
      ELSEIF(lepmode.EQ.'ANY') THEN
         ma_lep_mode=ma_lep_any
      ELSEIF(lepmode.EQ.'B') THEN
         ma_lep_mode=ma_lep_B
      ELSEIF(lepmode.EQ.'Y'.OR.
     $       lepmode.EQ.'UPSILON') THEN
         ma_lep_mode=ma_lep_Y
      ELSEIF(lepmode.EQ.'BSEM') THEN
         ma_lep_mode=ma_lep_Bsem
      ELSEIF(lepmode.EQ.'CSEM') THEN
         ma_lep_mode=ma_lep_Csem
      ELSEIF(lepmode.EQ.'+GOLD') THEN
         ma_lep_mode=IOR(ma_lep_mode,ma_lep_golden)
      ELSEIF(lepmode.EQ.'+JPSI') THEN
         ma_lep_mode=IOR(ma_lep_mode,ma_lep_JPsi)
      ELSEIF(lepmode.EQ.'+ANY') THEN
         ma_lep_mode=IOR(ma_lep_mode,ma_lep_any)
      ELSEIF(lepmode.EQ.'+B') THEN
         ma_lep_mode=IOR(ma_lep_mode,ma_lep_B)
      ELSEIF(lepmode.EQ.'+Y'.OR.
     $       lepmode.EQ.'+UPSILON') THEN
         ma_lep_mode=IOR(ma_lep_mode,ma_lep_Y)
      ELSEIF(lepmode.EQ.'+BSEM') THEN
         ma_lep_mode=IOR(ma_lep_mode,ma_lep_Bsem)
      ELSEIF(lepmode.EQ.'+CSEM') THEN
         ma_lep_mode=IOR(ma_lep_mode,ma_lep_Csem)
      ELSEIF(lepmode.EQ.'CLEAR') THEN
         ma_lep_mode=0
      ELSEIF(lepmode.EQ.'') THEN
      ELSE
         WRITE(*,*) ' Invalid input - try one of'
         WRITE (*,*), '            ','[+]GOLD'
         WRITE (*,*), '            ','[+]JPSI'
         WRITE (*,*), '            ','[+]Y'
         WRITE (*,*), '            ','[+]UPSILON'
         WRITE (*,*), '            ','[+]BSEM'
         WRITE (*,*), '            ','[+]CSEM'
         WRITE (*,*), '            ','CLEAR'
         WRITE (*,*), ' Don''t blame me if your guess of the',
     $        ' meaning is wrong ... ask me (PJW)'
      ENDIF

      IF(IAND(ma_lep_mode,ma_lep_golden).NE.0)
     $     WRITE(*,*) '   Golden    Lepton Mode'
      IF(IAND(ma_lep_mode,ma_lep_JPsi).NE.0)
     $     WRITE(*,*) '    J/Psi    Lepton Mode'
      IF(IAND(ma_lep_mode,ma_lep_any).NE.0)
     $     WRITE(*,*) '    any      Lepton Mode'
      IF(IAND(ma_lep_mode,ma_lep_B).NE.0)
     $     WRITE(*,*) '     B       Lepton Mode'
      IF(IAND(ma_lep_mode,ma_lep_Y).NE.0)
     $     WRITE(*,*) '    Ups*     Lepton Mode'
      IF(IAND(ma_lep_mode,ma_lep_Bsem).NE.0)
     $     WRITE(*,*) ' semilept. B Lepton Mode'
      IF(IAND(ma_lep_mode,ma_lep_Csem).NE.0)
     $     WRITE(*,*) ' semilept. C Lepton Mode'

      IF(ma_lep_mode.EQ.0)
     $     WRITE(*,*) ' Lepton Mode is void !!'

      END
      



