      SUBROUTINE MAKURKSET()
************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Called by KUIP to interactivly set some parameters
*                  used by the RK and its calling routines
************************************************************************
      IMPLICIT NONE

      REAL precx,precy,prectx,precty,xrlen,yrlen,txrlen,tyrlen,prlen
      INTEGER fstep,iter

#include "match98.fi"

      CALL KUGETR(precx)
      CALL KUGETR(precy)
      CALL KUGETR(prectx)
      CALL KUGETR(precty)
      CALL KUGETI(fstep)
      CALL KUGETI(iter)
      CALL KUGETR(xrlen)
      CALL KUGETR(yrlen)
      CALL KUGETR(txrlen)
      CALL KUGETR(tyrlen)
      CALL KUGETR(prlen)

      IF(ma_rk_set.NE.ma_gic_true) THEN
         WRITE(*,*) 'First time RK Paramters are set'
         ma_rkprec(1)  = ma_rkprec1_default
         ma_rkprec(2)  = ma_rkprec2_default
         ma_rkprec(3)  = ma_rkprec3_default
         ma_rkprec(4)  = ma_rkprec4_default
         ma_rkfstep    = ma_rkfstep_default
         ma_rkiter     = ma_rkiter_default
c         ma_txfit_noise = ma_txfit_noise_default
c         ma_tyfit_noise = ma_tyfit_noise_default
         ma_xfit_rlen  = ma_xfit_rlen_default
         ma_yfit_rlen  = ma_yfit_rlen_default
         ma_txfit_rlen = ma_txfit_rlen_default
         ma_tyfit_rlen = ma_tyfit_rlen_default
         ma_pfit_rlen  = ma_pfit_rlen_default
         ma_rk_set=ma_gic_true
      ENDIF

      IF(precx.GE.-.5)   ma_rkprec(1)  = precx
      IF(precy.GE.-.5)   ma_rkprec(2)  = precy
      IF(prectx.GE.-.5)  ma_rkprec(3)  = prectx
      IF(precty.GE.-.5)  ma_rkprec(4)  = precty
      IF(iter.GT.0)      ma_rkiter     = iter
      IF(fstep.GT.0)     ma_rkfstep    = fstep
      IF(xrlen.GE.-10.)  ma_xfit_rlen  = xrlen
      IF(yrlen.GE.-10.)  ma_yfit_rlen  = yrlen
      IF(txrlen.GE.-10.) ma_txfit_rlen = txrlen
      IF(tyrlen.GE.-10.) ma_tyfit_rlen = tyrlen
      IF(prlen.GE.-10.)  ma_pfit_rlen  = prlen

      WRITE(*,*) ' RK Parameters:'
      WRITE(*,*) '  Prec. x  * dist. =',ma_rkprec(1)
      WRITE(*,*) '        y          =',ma_rkprec(2)
      WRITE(*,*) '        tx         =',ma_rkprec(3)
      WRITE(*,*) '        ty         =',ma_rkprec(4)
      WRITE(*,*) '  fstep            =',ma_rkfstep  
      WRITE(*,*) '  iter             =',ma_rkiter  
      WRITE(*,*) ''
      WRITE(*,*) ' fit rlen      tx  =',ma_txfit_rlen
      WRITE(*,*) '               ty  =',ma_tyfit_rlen
      WRITE(*,*) '                x  =',ma_xfit_rlen
      WRITE(*,*) '                y  =',ma_yfit_rlen
      WRITE(*,*)
      WRITE(*,*) '                p  =',ma_pfit_rlen
      END
      
