      SUBROUTINE MAKUSHOW
************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Called by KUIP to show on request some settings and
*                  statistics of the match98 package.
*
************************************************************************
      IMPLICIT NONE

#include "match98.fi"
#include "matarx.fi"

      INTEGER i

c --- Settings: -------------------

      WRITE(*,*), ' Settings: '

      IF(ma_cuts_set.EQ.ma_gic_true) THEN
         WRITE(*,*) 'Cuts have been set'
      ELSE
         WRITE(*,*) 'Cuts have not been set'
      ENDIF

      WRITE(*,*) 'Selected Cuts:'
      WRITE(*,*) ' x =',ma_x_cut
      WRITE(*,*) ' y =',ma_y_cut
      WRITE(*,*) ' tx=',ma_tx_cut
      WRITE(*,*) ' ty=',ma_ty_cut

      IF(ma_lep_mode.EQ.ma_lep_golden) THEN
         WRITE(*,*) 'selecting golden leptons'
      ELSEIF(ma_lep_mode.EQ.ma_lep_JPsi) THEN
         WRITE(*,*) 'selecting JPsi leptons'
      ELSEIF(ma_lep_mode.EQ.ma_lep_Y) THEN
         WRITE(*,*) 'selecting Y leptons'
      ELSEIF(ma_lep_mode.EQ.ma_lep_any) THEN
         WRITE(*,*) 'selecting any leptons'
      ELSE
         WRITE(*,*) 'unknown lepton selection'
      ENDIF

      IF(IAND(ma_det_mode,ma_det_ecal).NE.0) THEN
         WRITE(*,*) 'Detector: simulating(?) ECAL'
         WRITE(*,'('' dE='',F6.2,''%'')'),ma_de*100
         WRITE(*,*) 'ecal_mode   :',ma_ecal_mode
c         WRITE(*,*) 'dp cut      :',ma_dp_cut*100.,'%'
      ENDIF
      IF(IAND(ma_det_mode,ma_det_muon).NE.0) THEN
         WRITE(*,*) 'Detector: simulating(?) Muon'
      ENDIF
      WRITE(*,*) 'Verbosity level:',ma_verblvl
c --- This Events' matches: ----------------------

      WRITE(*,*), ' This Event: '

      WRITE(*,*)              ' particle rtra     mtra'
      DO i=1,eplus_n
         WRITE(*,'(a,I6,I6)') ' e+   ',eplus_rtra(i),eplus_mtra(i)
      ENDDO
      DO i=1,eminus_n
         WRITE(*,'(a,I6,I6)') ' e-   ',eminus_rtra(i),eminus_mtra(i)
      ENDDO
      DO i=1,muplus_n
         WRITE(*,'(a,I6,I6)') ' mu+  ',muplus_rtra(i)
      ENDDO
      DO i=1,muminus_n
         WRITE(*,'(a,I6,I6)') ' mu-  ',muminus_rtra(i)
      ENDDO

      DO i=1,lplus_n
         WRITE(*,'(a,I6,I6)') ' l+   ',lplus_rtra(i)
      ENDDO
      DO i=1,lminus_n
         WRITE(*,'(a,I6,I6)') ' l-   ',lminus_rtra(i)
      ENDDO

c --- Results: -------------------
      WRITE(*,*), ' Summs: '

      WRITE(*,'(''ecal lookups :'',i5)'),ma_ecal_lup      
      IF(ma_ecal_lup.GT.0) THEN
         WRITE(*,'(''ecal founds  :'',i5,'' eff :'',f5.3)') ,
     $     ma_ecal_fnd,ma_ecal_fnd/FLOAT(ma_ecal_lup)
         WRITE(*,'(''ecal funny rl:'',i5)'),ma_funrl_cnt      
      ENDIF   

      WRITE(*,'(''horizontal w.:'',i5)'),ma_wire_hori_cnt
      WRITE(*,'(''vertical wire:'',i5)'),ma_wire_vert_cnt
      WRITE(*,'(''no wire      :'',i5)'),ma_wire_none_cnt

      WRITE(*,'(''txfit errors :'',i5)'),ma_txfit_errors

      WRITE(*,*) 'Matches tried                           :',
     $                                             match_try_cnt
      WRITE(*,*) 'tfrfseg Errors so far                   :',
     $                                             ma_tfrfsegerrcnt
      WRITE(*,*) 'tfrfseg Failures so far                 :',
     $                                             ma_tfrfsegfailcnt
      WRITE(*,*) 'tfrfseg Fits     so far                 :',
     $                                             ma_tfrfsegsucccnt

      WRITE(*,'(''e match poss      :'',i5)'),ematch_poss_cnt
      IF(ematch_poss_cnt.GT.0) THEN 
c         WRITE(*,'(''e match tries  :'',i5)'),ematch_try_cnt
         WRITE(*,'(''e match ok     :'',i5,'' eff :'',f5.3)') ,
     $     ematch_fnd_cnt,
     $     ematch_fnd_cnt/FLOAT(ematch_poss_cnt)
         WRITE(*,'(''e match ghost  :'',i5,'' rate:'',f5.3,a)') ,
     $     ematch_ghost_cnt-ematch_chrghost_cnt,
     $  (ematch_ghost_cnt-ematch_chrghost_cnt)/FLOAT(ematch_poss_cnt),
     $        '(Without "e match q ghost")'
         WRITE(*,'(''e match q ghost:'',i5,'' rate:'',f5.3)') ,
     $     ematch_chrghost_cnt,
     $     ematch_chrghost_cnt/FLOAT(ematch_poss_cnt)
         WRITE(*,*) 'Selected ECAL sampling factors:',
     $        ma_e1samp,ma_e2samp,ma_e5samp

      ENDIF

      WRITE(*,'(''mu match poss :'',i5)'),mumatch_poss_cnt
      IF(mumatch_poss_cnt.GT.0) THEN
         WRITE(*,'(''mu match ok   :'',i5,'' eff :'',f5.3)') ,
     $     mumatch_fnd_cnt,
     $     mumatch_fnd_cnt/FLOAT(mumatch_poss_cnt)
         WRITE(*,'(''mu match ghost  :'',i5,'' rate:'',f5.3,a)') ,
     $     mumatch_ghost_cnt-mumatch_chrghost_cnt,
     $(mumatch_ghost_cnt-mumatch_chrghost_cnt)/FLOAT(mumatch_poss_cnt)
      ENDIF

      WRITE(*,'(''match poss :'',i5)'),match_poss_cnt
      IF(match_poss_cnt.GT.0) THEN
         WRITE(*,'('' match ok   :'',i5,'' eff :'',f5.3)') ,
     $     match_fnd_cnt,
     $     match_fnd_cnt/FLOAT(match_poss_cnt)
         WRITE(*,'('' match ghost  :'',i5,'' rate:'',f5.3,a)') ,
     $     match_ghost_cnt-match_chrghost_cnt,
     $(match_ghost_cnt-match_chrghost_cnt)/FLOAT(match_poss_cnt),
     $        '(Without " match q ghost")'
         WRITE(*,'('' match q ghost:'',i5,'' rate:'',f5.3)') ,
     $     match_chrghost_cnt,
     $     match_chrghost_cnt/FLOAT(match_poss_cnt)


      ENDIF

      END
      
