      subroutine mamc2lepseg()

      implicit none

************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*                  using code by Rainer Mankel 
*     Description: fills RSEG Table rows with information retrieved from the
*                  MC information simulating the muon detector reconstruction
*                  to be used as a seed for the upstream RANGER algorithm
*
************************************************************************

#include "arte/Arte.fi"
#include "auto/MTRA.fi"
#include "match98.fi"
#include "mapstat.fi"

      INTEGER irseg_new,imtra,ngold,i
      INTEGER ierror
      REAL x,y,tx,ty,dz,eta,dx(5)

#include "arte/Arte.ff"
#include "auto/MTRA.ff"

      CALL matuloclep()

      DO ngold=1,ma_pstat_n        ! loop over lepton candidates
         DO i=pstat_lplus,pstat_lminus,pstat_lminus-pstat_lplus
            imtra=ma_pstat(i,ngold)
            IF(imtra.NE.0) THEN
               IF(OMTRA_TOPP(imtra).EQ.code_muplus.OR.
     $            OMTRA_TOPP(imtra).EQ.code_muminus) THEN

                  IF(IAND(ma_det_mode,ma_det_muon).NE.0) THEN
                     IF(ma_verblvl.GE.10) WRITE(*,*)' mamc2lepseg:',
     $                    'calling ma*MU*seg_mtra for imtra=',imtra
                     CALL mamuseg_mtra(imtra,ierror)
                  ELSE
                     IF(ma_verblvl.GE.11) WRITE(*,*)' mamc2lepseg:',
     $                    'skipping muon ',imtra
                  ENDIF

               ELSEIF(OMTRA_TOPP(imtra).NE.code_eplus.OR.
     $              OMTRA_TOPP(imtra).NE.code_eminus) THEN

                  IF(IAND(ma_det_mode,ma_det_ecal).NE.0) THEN
                     IF(ma_verblvl.GE.10) WRITE(*,*) ' mamc2lepseg:',
     $                 'calling ma*EL*seg_mtra for imtra=',imtra
                     CALL maelseg_mtra(imtra,ierror)
                  ELSE
                     IF(ma_verblvl.GE.11) WRITE(*,*)' mamc2lepseg:',
     $                    'skipping electron ',imtra
                  ENDIF

               ELSE
                  IF(ma_verblvl.GE.3) WRITE(*,*) ' mamc2lepseg:',
     $                 'strange kind of lepton(',imtra,') - skipped'
               ENDIF
            ELSE
               IF(ma_verblvl.GE.10) WRITE(*,*) ' mamc2lepseg:',
     $              'ma_pstat(',i,',',ngold,') = 0 - skipped'
            ENDIF
         ENDDO
      ENDDO

      RETURN
      END

