      subroutine mamcmuseg()

      implicit none

************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*                  using code by Rainer Mankel 
*     Description: fills RSEG Table rows with information retrieved from the
*                  MC information simulating the muon detector reconstruction
*                  to be used as a seed for the upstream RANGER algorithm
*
************************************************************************

#include "match98.fi"
#include "mapstat.fi"

      INTEGER irseg_new,imtra,ngold,i
      INTEGER ierror
      REAL zmu,x,y,tx,ty,dz,eta,dx(5)
      PARAMETER(zmu = 1600.)
      REAL sx,sy,stx,sty
*      parameter (sx=.5,sy=2.,stx=.002,sty=.027) ! mu resolution
*      parameter (sx=.4,sy=1.4,stx=.007,sty=.018) ! mu resolution
      parameter (sx=.17,sy=.92,stx=.012,sty=.020) ! mu resolution

      CALL matuloclep()

      DO ngold=1,ma_pstat_n        ! loop over lepton candidates
         DO i=pstat_lplus,pstat_lminus,pstat_lminus-pstat_lplus
            imtra=ma_pstat(ngold,i)
            IF(imtra.NE.0) THEN
               IF(ma_verblvl.GE.10) WRITE(*,*)
     $        ' macmuseg: calling mamuseg_mtra for imtra=',imtra
               CALL mamuseg_mtra(imtra,ierror)
            ENDIF
         ENDDO
      ENDDO

      RETURN
      END

