      subroutine maopti()

*     **** flag out compatible tracks

      implicit none
c      integer max_mu
c      parameter (max_mu=100)
c      common /mu/ n_mu, seg1_mu(max_mu), seg2_mu(max_mu),
c     +     segm_mu(max_mu), tra_mu(max_mu)
c
c      integer n_mu              ! number of entries
c      integer seg1_mu           ! pointer to 1st RSEG
c      integer seg2_mu           ! pointer to 2nd RSEG
c      integer segm_mu           ! pointer to output seg
c      integer tra_mu            ! pointer to fitted RTRA

#include "arte/Arte.fi"
#include "auto/GEO.fi"
#include "auto/HITB.fi"
#include "auto/RTRA.fi"
#include "auto/RTRX.fi"
#include "match98.fi"
      integer max_relat
      parameter (max_relat=20)
      integer n_relat,          ! number of related tracks stored
     +     rt_relat(max_relat)  ! rtra-id of relations

      integer rt1,rt2,mc1,mc2,nhit1,nhit2,i_relat,
     +     n_before,n_after,lep1,lep2
      real quality_1,quality_2
#include "arte/Arte.ff"
#include "auto/GEO.ff"
#include "auto/HITB.ff"
#include "auto/RTRA.ff"
#include "auto/RTRX.ff"
      
      n_before = 0
      n_after  = 0

      do 10 lep1=1,ma_n   ! loop over all tracks
         n_before = n_before + 1
         rt1 = ma_rtra(lep1)
         if (rt1.eq.0) go to 10 ! not fitted
         if (irtra_fit(rt1).lt.0) go to 10 ! already removed
         nhit1 = irtra_hsi(rt1) + irtra_hou(rt1) 
     +        + irtra_hri(rt1)

         if (prtrx_mtra(rt1).gt.0) then
            mc1 = mrtrx_mtra(prtrx_mtra(rt1))
         else
            mc1 = 0
         endif

         n_relat = 0            ! reset relation arrays
         do 20 lep2=lep1+1,ma_n   ! loop over other tracks
            rt2 = ma_rtra(lep2)
            if (rt2.eq.0) go to 20 ! not fitted
            if (irtra_fit(rt2).lt.0) go to 20 ! already removed

            if (ma_rseg1(lep1).eq.ma_rseg1(lep2)
     +           .or.ma_rseg2(lep1).eq.ma_rseg2(lep2)) then ! related

               if (n_relat.lt.max_relat) then
                  n_relat = n_relat + 1 ! fill relation
                  rt_relat(n_relat) = rt2
               else
                  IF(ma_verblvl.GE.5)
     $                 print *,' () maopti: overflowing n_relat=',
     +                 n_relat
                  go to 20
               endif
            endif
 20      continue


*         quality_1 = nhit1 - frtra_chi(rt1)
         quality_1 = - frtra_chi(rt1)

*        **** evaluate relations for rt1
         do 60 i_relat=1,n_relat
            rt2 = rt_relat(i_relat)
            nhit2 = irtra_hsi(rt2) + irtra_hou(rt2) 
     +           + irtra_hri(rt2)

*            quality_2 = nhit2 - frtra_chi(rt2)
            quality_2 = - frtra_chi(rt2)
            
            if (prtrx_mtra(rt2).gt.0) then
               mc2 = mrtrx_mtra(prtrx_mtra(rt2))
            else
               mc2 = 0
            endif

            IF(ma_verblvl.GE.9)
     $           print *,' =============',rt1,'  vs ',rt2,' ====='
            if (nhit1.gt.0.and.nhit2.gt.0) then
               
               if (quality_1.lt.quality_2) then ! kill rt1
                  iq(iqrtra_fit(rt1)) = -iabs(irtra_fit(rt1))
                     
                  IF(ma_verblvl.GE.9)
     $              print '(2(3(a5,i5),a7,f8.2/),a8,i5,(a),i5/)',
     +                 ' rt1=',rt1,' mc1=',mc1,' nhit1=',nhit1,
     +                 ' qual_1=',quality_1,
     +                 ' rt2=',rt2,' mc2=',mc2,' nhit2=',nhit2,
     +                 ' qual_2=',quality_2,
     +                 ' ---> kill rt1=',rt1

                  go to 10      ! rt1 is dead
               else             ! kill rt2
                  iq(iqrtra_fit(rt2)) = -iabs(irtra_fit(rt2))
                  
                  IF(ma_verblvl.GE.9)
     $               print '(2(3(a5,i5),a7,f8.2/),a8,i5,(a),i5/)',
     +                 ' rt1=',rt1,' mc1=',mc1,' nhit1=',nhit1,
     +                 ' qual_1=',quality_1,
     +                 ' rt2=',rt2,' mc2=',mc2,' nhit2=',nhit2,
     +                 ' qual_2=',quality_2,
     +                 ' ---> kill rt2=',rt2
               endif
            endif
 60      continue               ! i_relat

 10   continue

      do lep1=1,ma_n
         rt1 = ma_rtra(lep1)
         if (irtra_fit(rt1).gt.0) n_after = n_after + 1
      enddo

      IF(ma_verblvl.GE.8)
     $  print *,' maopti: n_before=',n_before,'  n_after=',n_after

      end
