      LOGICAL FUNCTION mapseudoecal(xyz,dxyz,E,dE,imtra,imimp)

      IMPLICIT NONE

************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Very crude Ecal Simulation
      
      REAL xyz(3),dxyz(3) ! out   Ecal hit coordinates and errors
      REAL E,dE           ! out   "Measured" energy and errors
      INTEGER imtra       ! in    Row of MTRA table of particle, for which
                          !       an Ecal hit shall be simulated
      INTEGER imimp       ! out   Last MIMP of particle in front of the ECAL
*
************************************************************************

#include "arte/Arte.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/MIMP.fi"
#include "auto/TOPP.fi"
#define MAPSEUDOECAL_FUNC_DEF
#include "match98.fi"

      INTEGER indx
      REAL mc_q
      REAL random ! Output of random generator

#include "arte/Arte.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/MIMP.ff"
#include "auto/TOPP.ff"


      REAL z_ecal ! Value of Z where to emulate ECAL hits

      PARAMETER ( z_ecal = 1450 )
c      PARAMETER ( z_ecal = 700 )

      IF(ma_verblvl.GE.18) WRITE(*,*) ' mapseudoecal:',
     $     'imtra=',imtra
      indx=0
      DO WHILE(maslcmimp_mtra(imimp,indx,imtra))
         IF((z_ecal-150)  .LT.FMIMP_Z(imimp).AND.
     $      FMIMP_Z(imimp).LT.z_ecal             ) THEN
            IF(ma_verblvl.GE.18) WRITE(*,*) ' mapseudoecal:',
     $           'mimp taken',imimp

             xyz(1)=FMIMP_X(imimp)
             xyz(2)=FMIMP_Y(imimp)
             xyz(3)=FMIMP_Z(imimp)

c ---  Spacial resolutions taken from the TDR p. 314: ---
c              IF(nbl.EQ.1)THEN
c                 dxyz(1)=1.7
c                 dxyz(2)=1.5
c                 dE=0.17
c              ELSEIF(nbl.EQ.2)THEN
c                 dxyz(1)=0.82
c                 dxyz(2)=0.65
c                 dE=0.17
c              ELSEIF(nbl.EQ.5)THEN
c                 dxyz(1)=0.33
c                 dxyz(2)=0.25
c                 dE=0.095
c              ELSE
             dxyz(1)=1.
             dxyz(2)=1.
             dxyz(3)=1.
             dE=0.15
c             dxyz(1)=0.0001
c             dxyz(2)=0.0001
c             dxyz(3)=0.0001
c             dE=0.0000015

            mc_q=ITOPP_CHRG(OMTRA_TOPP(imtra))/3.
            E=SIGN(SQRT(FTOPP_MASS(OMTRA_TOPP(imtra))**2+
     $             FMIMP_P(imimp)**2),
     $                       mc_q)
            CALL HF1(mahb_z,xyz(3),1.)

            CALL NORRAN(random)
            xyz(1)=xyz(1)+random*dxyz(1)
            CALL NORRAN(random)
            xyz(2)=xyz(2)+random*dxyz(2)

            CALL maEsmear(E,dE)
            mapseudoecal=.TRUE.
            RETURN
         ENDIF
      ENDDO
      mapseudoecal=.FALSE.
      RETURN
      END

