      INTEGER FUNCTION MASELGTAR(ngold,error)
      
      IMPLICIT NONE

************************************************************************
* Author     : Peter J. Weyers <weyers@ifh.de>
*
* Description: Returns the GTAR row number of the wire "closest" to the 
*              primary vertex of the decay selected by match98/leptonmode
*              Returns 0 in case of error
* Arguments:

      INTEGER ngold   ! in   Number of golden event to use   
      INTEGER error   ! out  = 0 : success                          

************************************************************************

#include "arte/Arte.fi"
#include "auto/GTAR.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/MVER.fi"
#include "mapstat.fi"
#define MASELGTAR_FUNC_DEF
#include "match98.fi"

      INTEGER ibver,JPsi_ibver
      INTEGER imtra
      INTEGER pstat_i
      INTEGER gtar_ir
      REAL    ver_x,ver_y ! Koordinates of the MC primary B0 vertex
      REAL    ver_z
      REAL    tar_x,tar_y,tar_z
      REAL    min_dist_sq,dist_sq
c       REAL    mu_x,mu_y         ! mu MC track parameters of extrapolation
c                           ! to target z value
      REAL    mx,my,bx,by
c       INTEGER pstat_lplus,pstat_lminus
c       PARAMETER(pstat_lplus   = 1,
c      $          pstat_lminus  = 2)

#include "arte/Arte.ff"
#include "auto/GTAR.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/MVER.ff"

************************************************************************

      CALL matuloclep()

      IF(ma_pstat_n.GT.0)THEN
         IF(ngold.GE.0.AND.ngold.LE.ma_pstat_n) THEN
            error=0

            IF(ma_pstat(pstat_B0,ngold).NE.0)THEN
               IF(ma_verblvl.GE.8)
     $            WRITE (*,*)
     $              ' maselgtar: taking B target coordinates,ngold=',
     $              ngold
               imtra=ma_pstat(pstat_B0,ngold)
               maselgtar=magetgtar(imtra,error)
            ELSEIF(ma_pstat(pstat_JPsi,ngold).NE.0) THEN
               IF(ma_verblvl.GE.8)
     $            WRITE (*,*)
     $              ' maselgtar: taking JPsi target coordinates,ngold=',
     $              ngold
               imtra=ma_pstat(pstat_JPsi,ngold)
               maselgtar=magetgtar(imtra,error)
            ELSE
               IF(ma_verblvl.GE.2) WRITE (*,*) 
     $              ' maselgtar:  no primary particle in ma_pstat'
               maselgtar=0
               error=1
            ENDIF
c            ver_x=FMVER_X(ibver)
c            ver_y=FMVER_Y(ibver)
c            tar_z=FMVER_Z(ibver)
c   
cc            nsigma=.00001 ! for target geometry
c   
c            IF(ABS(ver_x).LT.0.2)THEN ! horizontal wire
c               IF(ma_verblvl.GE.8)
c     $           WRITE(*,*) ' maselgtar: horizontal wire'
c               tar_x=0
c               tar_y=ver_y
c            ELSE                       ! vertical wire
c               IF(ma_verblvl.GE.8)
c     $           WRITE(*,*) ' maselgtar: vertical wire'
c               tar_x=ver_x
c               tar_y=0
c            ENDIF
c            maselgtar=1
c            min_dist_sq=1000.
c            DO gtar_ir=2,NGTAR()
c               dist_sq=(tar_x-FGTAR_X(gtar_ir))**2+
c     $              (tar_y-FGTAR_Y(gtar_ir))**2+
c     $              (tar_z-FGTAR_Z(gtar_ir))**2
c               IF(ma_verblvl.GE.8)
c     $            WRITE(*,*) ' maselgtar: Wire:',gtar_ir,
c     $                       ' dist:',SQRT(dist_sq)
c               IF(dist_sq.LE.min_dist_sq) THEN
c                  min_dist_sq=dist_sq
c                  maselgtar=gtar_ir
c               ENDIF
c            ENDDO
c            GOTO 999
         ENDIF
      ENDIF
      
 999  CONTINUE
      RETURN

      END

************************************************************************
* End of MASELGTAR
************************************************************************
