      SUBROUTINE MASETTARX(gtar_ir,error)
      
      IMPLICIT NONE

************************************************************************
* Author     : Peter J. Weyers <weyers@ifh.de>
* Description: Fills the koordinates of target wire given by the GTAR row
*              number in the COMMON /ma98_tarx/ defined in  matarx.fi
*
* Arguments:

      INTEGER gtar_ir ! Row number of Target Wire in GTAR
      INTEGER error   ! out  = 0 : success                          
                      !      = 1 : invalid Row number, default coordinates
*                                  corresponding to no target wire used
*
************************************************************************

#include "arte/Arte.fi"
#include "auto/GTAR.fi"
c #include "pris/zpstat.fi"
#include "match98.fi"
#include "matarx.fi"

      REAL    wsigma      ! sigma of wide   target constraint
      REAL    nsigma      ! sigma of narrow target constraint

#include "arte/Arte.ff"
#include "auto/GTAR.ff"

************************************************************************
      
      IF(gtar_ir.LE.0.OR.gtar_ir.GT.NGTAR()) THEN
         ma_tar(1)=0
         ma_tar(2)=0
         ma_tar(3)=0
         ma_dtar(1)=0.225
         ma_dtar(2)=0.18
         ma_wire_none_cnt=ma_wire_none_cnt+1
         error=1
         return
      ENDIF


      wsigma=.05
      nsigma=0.015   ! for mu track
c      nsigma=.00001 ! for target geometry
      

      ma_tar(1)=FGTAR_X(gtar_ir)
      ma_tar(2)=FGTAR_y(gtar_ir)
      ma_tar(3)=FGTAR_Z(gtar_ir)

      IF(ABS(ma_tar(1)).LT.ABS(ma_tar(2)))THEN ! horizontal wire
         IF(ma_verblvl.GE.8)
     $        WRITE(*,*) ' masettarx: horizontal wire'
         ma_dtar(1)=wsigma
         ma_dtar(2)=nsigma
         ma_wire_hori_cnt=ma_wire_hori_cnt+1
      ELSE                       ! vertical wire
         IF(ma_verblvl.GE.8)
     $        WRITE(*,*) ' masettarx: vertical wire'
         ma_dtar(1)=wsigma
         ma_dtar(2)=nsigma
         ma_wire_vert_cnt=ma_wire_vert_cnt+1
      ENDIF

      error=0

      RETURN

      END



************************************************************************
* End of MASETTARX
************************************************************************
