      LOGICAL FUNCTION MASLCMIMP_MTRA(imimp,indx,imtra)
      
      IMPLICIT NONE

************************************************************************
* Author     : Peter J. Weyers <weyers@ifh.de>
* Description: Selects MIMP corresponding to MTRA
*              Returns .TRUE. if a MIMP was found, else .FALSE.
*

      INTEGER imimp  ! out  MIMP corresponding to MTRA, =0 if no more found
      INTEGER indx   !      buffer to save state of loop. 
                     ! in   =0 means to start loop
                     ! out  =0 means no more MIMPS 
      INTEGER imtra  ! in   MTRA row number for which corresponding MIMPS are
*                           searched
*
************************************************************************

#include "arte/Arte.fi"
#include "auto/MIMP.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"

      INTEGER i

#include "arte/Arte.ff"
#include "auto/MIMP.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"


************************************************************************

      IF(imtra.EQ.0) THEN
         indx=0
         maslcmimp_mtra=.FALSE.
         RETURN
      ENDIF

      IF(indx.EQ.0) THEN
         indx=PMTRX_MIMP(imtra)
      ELSE
         indx=XMTRX_MIMP(indx)
      ENDIF

      IF(indx.NE.0) THEN
         maslcmimp_mtra=.TRUE.
         imimp=MMTRX_MIMP(indx)
c         WRITE (*,*) ' maslcmimp_mtra: found mimp',imimp
      ELSE
         maslcmimp_mtra=.FALSE.
c         WRITE (*,*) ' maslcmimp_mtra: no further mimp'
         imimp=0
      ENDIF
      RETURN
      END

************************************************************************
* End of MASLCMIMP_MTRA
************************************************************************










