*-- Author :    Hartwig Albrecht   04/02/95

      SUBROUTINE MATCH98INIT

************************************************************************
* Author     : Peter J. Weyers <weyers@ifh.de>
* Description: Initialisation of match98 package. Sets counters and books
*              Histograms
*
************************************************************************

      IMPLICIT NONE

#include "arte/Arte.fi"
#include "auto/TOPP.fi"
#include "match98.fi"
c #include "run98.fi"

      REAL scale

#include "arte/Arte.ff"
#include "auto/TOPP.ff"


      print *,' start match98init'



c   counters:      

      ematch_fnd_cnt      =  0
      ematch_ghost_cnt    =  0
      ematch_chrghost_cnt =  0
      ematch_poss_cnt     =  0
      ematch_try_cnt      =  0

      mumatch_fnd_cnt     =  0
      mumatch_ghost_cnt   =  0
      mumatch_chrghost_cnt=  0
      mumatch_poss_cnt    =  0

      match_try_cnt       =  0
      match_fnd_cnt       =  0
      match_ghost_cnt     =  0
      match_chrghost_cnt  =  0
      match_poss_cnt      =  0

      ma_ecal_lup         =  0
      ma_ecal_fnd         =  0
      ma_funrl_cnt        =  0
      ma_wire_hori_cnt    =  0
      ma_wire_vert_cnt    =  0
      ma_wire_none_cnt    =  0
      ma_txfit_errors     =  0
      ma_pfit98_errors    =  0

      ma_tfrfsegerrcnt    =  0
      ma_tfrfsegfailcnt   =  0
      ma_tfrfsegsucccnt   =  0



c ECAL settings:

c      ma_lep_mode       = 1
c      ma_dE             = 0.05
c      ma_ecal_mode      = 0
c      ma_dp_cut         = 1.

      muplus_n          = 0
      muminus_n         = 0

      ma_n              = 0

      eplus_n           = 0
      eminus_n          = 0


      IF(ma_verblvl_set.NE.ma_gic_true) THEN
         ma_verblvl=4
         ma_verblvl_set=ma_gic_true
         WRITE(*,*) ' match98init: Verbosity set to 4'
      ENDIF

      IF(ma_esamp_set.NE.ma_gic_true) THEN
         ma_e1samp=6.7
         ma_e2samp=6.7
         ma_e5samp=30.00
         ma_esamp_set=ma_gic_true
         IF(ma_verblvl.GE.8) WRITE(*,*) ' match98init:',
     $        'Ecal Sampling factors set to 6.7 / 6.7 / 30.0'
      ENDIF

      IF(ma_det_mode_set.NE.ma_gic_true) THEN
         ma_det_mode=IOR(ma_det_ecal,ma_det_muon)
         ma_det_mode_set=ma_gic_true
         IF(ma_verblvl.GE.8) WRITE(*,*) ' match98init:',
     $        'Detector mode set to "both"'
      ENDIF

      IF(ma_rk_set.NE.ma_gic_true) THEN
         IF(ma_verblvl.GE.8) THEN
            WRITE(*,*) ' match98init:',
     $      ' Setting RK Paramters to default:'
            WRITE(*,*) '        ma_rkprec(1)=',ma_rkprec1_default
            WRITE(*,*) '        ma_rkprec(2)=',ma_rkprec2_default
            WRITE(*,*) '        ma_rkprec(3)=',ma_rkprec3_default
            WRITE(*,*) '        ma_rkprec(4)=',ma_rkprec4_default
            WRITE(*,*) '        ma_rkfstep  =',ma_rkfstep_default
            WRITE(*,*) '        ma_rkiter   =',ma_rkiter_default  
            WRITE(*,*) ''
            WRITE(*,*) ' fit rlen        tx  =',ma_txfit_rlen_default
            WRITE(*,*) '                 ty  =',ma_tyfit_rlen_default
            WRITE(*,*) '                  x  =',ma_xfit_rlen_default
            WRITE(*,*) '                  y  =',ma_yfit_rlen_default
         ENDIF
         ma_rkprec(1)  = ma_rkprec1_default
         ma_rkprec(2)  = ma_rkprec2_default
         ma_rkprec(3)  = ma_rkprec3_default
         ma_rkprec(4)  = ma_rkprec4_default
         ma_rkfstep    = ma_rkfstep_default
         ma_rkiter     = ma_rkiter_default
         ma_xfit_rlen  = ma_xfit_rlen_default
         ma_yfit_rlen  = ma_yfit_rlen_default
         ma_txfit_rlen = ma_txfit_rlen_default
         ma_tyfit_rlen = ma_tyfit_rlen_default
         ma_rk_set=ma_gic_true
      ENDIF

      CALL HBOOK1(mahb_z,'z?ECAL simu!',1341,-0.5,1340.5,0.)
c      CALL HBOOK1(mahb_zf,'zf?RSEG!',501,-25.05,25.05,0.)
      CALL HBOOK1(mahb_zf,'z?MIMP1!',501,-50.1,50.1,0.)

c      scale=1
      scale=0.1
      CALL HBOOK1(mahb_xtardiff ,'x?tar! - x?seg!',101,
     $     -2.02*scale,2.02*scale,0.) 

      CALL HBOOK1(mahb_ytardiff ,'y?tar! - y?seg!',101,
     $     -2.02*scale,2.02*scale,0.) 

c      scale=0.01
c      CALL HBOOK1(mahb_xtardiff ,'x?tar! - x?seg!',1001,
c     $     -0.25025*scale,0.25025*scale,0.) 
c
c      CALL HBOOK1(mahb_ytardiff ,'y?tar! - y?seg!',1001,
c     $     -0.25025*scale,0.25025*scale,0.) 

      scale=0.5

      CALL HBOOK1(mahb_erdiff,'E?mc!-E?smear!/E?mc!',101,
     $     -1.01*scale,1.01*scale,0.)

c ---------
      CALL HBOOK1(mahb_zdiff,'z?diff,ok!',201,-10.025,0.25,0.)

c      IF(scenario.EQ.1)THEN
c         scale=5
c      ELSE
         scale=1
c      ENDIF

      CALL HBOOK1(mahb_xdiff ,'x?fit! - x?svd!',101,
     $     -0.2525*scale,0.2525*scale,0.) 

      scale=1.

      CALL HBOOK1(mahb_ydiff ,'y?fit! - y?svd!',101,
     $     -0.2525*scale,0.2525*scale,0.) 

c      IF(scenario.EQ.1)THEN
c         scale=5
c      ELSE
c         scale=1
c      ENDIF

      scale=2.

      CALL HBOOK1(mahb_txdiff,
     $            '(tan [Q]?x!)?fit! - (tan [Q]?x!)?MIMP!',
     $                                     101,
     $     -0.00202*scale ,0.00202*scale,0.)
c      scale=1.
      CALL HBOOK1(mahb_tydiff,                                             
     $            '(tan [Q]?y!)?fit! - (tan [Q]?y!)?MIMP!',
     $                   101,-0.00202*scale,0.00202*scale,0.)

c      IF(scenario.EQ.1)THEN
c         scale=5
c      ELSE
c         scale=1
c      ENDIF

      CALL HBOOK1(mahb_txdiff2,
     $            '(tan [Q]?x!)?fit! - (tan [Q]?x!)?MIMP! (ECAL)',
     $                    101,-0.00202*scale,0.00202*scale,0.)
c      scale=1.
      CALL HBOOK1(mahb_tydiff2,                                             
     $            '(tan [Q]?y!)?fit! - (tan [Q]?y!)?MIMP! (ECAL)',
     $                   101,-0.00202*scale,0.00202*scale,0.)


c      IF(scenario.EQ.1)THEN
c         scale=5
c      ELSE
         scale=1
c      ENDIF

      scale=0.05

      CALL HBOOK1(mahb_dtx,
     $            '[s]?tan [Q]?x!!',
     $     101,-0.00202*scale ,0.00202*scale,0.)
      scale=0.05
      CALL HBOOK1(mahb_dty,                                             
     $            '[s]?tan [Q]?y!!',
     $                   101,-0.00202*scale,0.00202*scale,0.)



      scale=5
      CALL HBOOK1(mahb_txpull,
     $            '(tan [Q]?x!)?fit! - (tan [Q]?x!)?MIMP!/[s]',
     $     101,-1.01*scale ,1.01*scale,0.)
      CALL HBOOK1(mahb_typull,                                             
     $            '(tan [Q]?y!)?fit! - (tan [Q]?y!)?MIMP!/[s]',
     $     101,-1.01*scale ,1.01*scale,0.)
      CALL HBOOK1(mahb_txpull2,
     $            '(tan [Q]?x!)?fit! - (tan [Q]?x!)?MIMP!/[s] (ECAL)',
     $     101,-1.01*scale ,1.01*scale,0.)
      CALL HBOOK1(mahb_typull2,                                             
     $            '(tan [Q]?y!)?fit! - (tan [Q]?y!)?MIMP!/[s] (ECAL)',
     $     101,-1.01*scale ,1.01*scale,0.)
      CALL HBOOK1(mahb_ppull,                                             
     $            '(p?pfit! - p?MTRA!)/[s]',
     $     101,-1.01*scale ,1.01*scale,0.)
      CALL HBOOK1(mahb_epull,                                             
     $            '(E?Ecal! - E?MTRA!)/dE',
     $     101,-1.01*scale ,1.01*scale,0.)
      CALL HBOOK1(mahb_xtarpull,
     $            '(x?tar! - x?seg!)/[s]',
     $     101,-1.01*scale ,1.01*scale,0.)
      CALL HBOOK1(mahb_ytarpull,                                             
     $            '(y?tar! - y?seg!)/[s]',
     $     101,-1.01*scale ,1.01*scale,0.)
c -------
      CALL HBOOK1(mahb_zdiff2,'z?diff,ghost!',201,-10.025,0.25,0.)

c      IF(scenario.EQ.1)THEN
c         scale=50
c      ELSE
         scale=10
c      ENDIF

      CALL HBOOK1(mahb_xdiff2 ,'x?fit! - x?ghost!',101,
     $     -0.2525*scale,0.2525*scale,0.) 

      scale=10

      CALL HBOOK1(mahb_ydiff2 ,'y?fit! - y?ghost!',101,
     $     -0.2525*scale,0.2525*scale,0.) 

c      IF(scenario.EQ.1)THEN
c         scale=50
c      ELSE
c         scale=10
c      ENDIF
c
c      CALL HBOOK1(mahb_txdiff2,
c     $            '(tan [Q]?x!)?fit! - (tan [Q]?x!)?ghost!',
c     $                                     101,
c     $     -0.00202*scale ,0.00202*scale,0.)
c
c      scale=10.
c
c      CALL HBOOK1(mahb_tydiff2,                                             
c     $            '(tan [Q]?y!)?fit! - (tan [Q]?y!)?ghost!',
c     $                   101,-0.00202*scale,0.00202*scale,0.)


      scale=100.

      CALL HBOOK1(mahb_ediff,'E?MC!-E?MTRA!',
     $                           101,-1.01*scale,1.01*scale,0.)


      IF(ma_verblvl.GE.2) THEN
         WRITE(*,*) 'matchlib ''98  Version ',MA98_VERSION
         WRITE(*,*) ' end match98init '
      ENDIF
999   END

************************************************************************
* End of MATCH98INIT
************************************************************************



