

      SUBROUTINE matchsvd(rseg_ir,mtra_fix,ierror)

      IMPLICIT NONE
************************************
* Author     : Peter J. Weyers
* Description: Match SVD Segments to given segment
*
      INTEGER rseg_ir   ! Input : row number of given RSEG
      INTEGER mtra_fix  ! Input : associated MTRA, only for histogramming
      INTEGER ierror    ! pfit98 error (=0  -> OK)
*
**************************************************************************

#include "arte/Arte.fi"
#include "auto/HITB.fi"
#include "auto/RSEG.fi"
#include "auto/RHIT.fi"
#include "match98.fi"
#include "matarx.fi"

      INTEGER irseg_svd         ! row number of matched SVD RSEG
      INTEGER irseg_new         ! row number of new rseg
      INTEGER rseg_last         ! last of unmatched rsegs.
      INTEGER irhit,ihitb,imtra,irpnt
      
      REAL    qp_est
      INTEGER nrhits_max,nrhits
      PARAMETER (nrhits_max=100)
      INTEGER rhit_ir(nrhits_max)
      INTEGER indx,indx2,i,j,irhit_new
      LOGICAL flag,match_ok
C ----
      INTEGER match_cnt
C ----

#include "arte/Arte.ff"
#include "auto/HITB.ff"
#include "auto/RSEG.ff"
#include "auto/RHIT.ff"

      IF(ma_verblvl.GE.10)
     $     WRITE(*,*) ' matchsvd: Called to match',rseg_ir
c ----- find the match

      irseg_svd=0

      match_cnt=0

      CALL mapfit98(rseg_ir,ma_tar,ma_dtar,3,ierror)

      IF(ierror.NE.0) THEN
          IF(ma_verblvl.GE.5)
     $        WRITE(*,*) ' matchsvd: pfit ierror=',ierror
         ma_pfit98_errors=ma_pfit98_errors+1
         RETURN
      ENDIF

c      IF(mtra_fix.NE.0) THEN
c         DO j=1,NRSEG()
c            IF(IRSEG_CMP(j).EQ.RSEGc_vxd) THEN
c               CALL maifrsegmtra(j,mtra_fix,match_ok)
c               IF(match_ok) THEN
c                  CALL hfdiff_ok(j,rseg_ir)
c               ELSE
c                  CALL hfdiff_ghost(j,rseg_ir)
c               ENDIF
c            ENDIF
c         ENDDO
c      ENDIF

c     CALL mafisvds98(irseg_svd,rseg_ir)

      rseg_last=NRSEG() ! last irseg to be tried for matching

      CALL ma98fisvds(irseg_svd,rseg_ir,rseg_last)

      DO WHILE(irseg_svd.NE.0)

         IF(ma_verblvl.GT.9)
     $        WRITE(*,*) ' matchsvd: Found match',irseg_svd

c --- Do some counting             

         match_cnt=match_cnt+1           ! this rseg_ir

         IF(ma_n.LT.max_ma) THEN
            ma_n=ma_n+1
         ELSE
            IF(ma_verblvl.GE.5) WRITE(*,*) ' matchsvd:',
     $           ' ma_rseg(ma_n) overflow! max_ma=',max_ma
         ENDIF
         
         ma_rseg1(ma_n) = irseg_svd
         ma_rseg2(ma_n) = rseg_ir

c ------- if there is exactly one related MTRA, take it for eff. meas.
         ma_ok(ma_n)=0
         indx=PRSEG_MTRA(rseg_ir)
         IF(indx.NE.0)THEN
            IF(XRSEG_MTRA(indx).EQ.0) THEN
               CALL maifrsegmtra(irseg_svd,MRSEG_MTRA(indx),flag)
               IF(flag) THEN
c                  fndseg_cnt=fndseg_cnt+1
                  match_fnd_cnt=match_fnd_cnt+1
                  ma_ok(ma_n)=ma_gic_true
               ELSE
c                  wrongseg_cnt=wrongseg_cnt+1
                  match_ghost_cnt=match_ghost_cnt+1
                  ma_ok(ma_n)=ma_gic_false
               ENDIF
            ENDIF
         ENDIF
   
c ----- create new RSEG
         CALL MMBOOK(JRSEG,1)      ! increase row counter
         irseg_new = NRSEG()
         
         ma_rsegm(ma_n) = irseg_new

         qp_est=FRSEG_PF(rseg_ir)
   
   
c --------- Fill RSEG row entries 
   
         Q(QRSEG_ZF_L())  =  FRSEG_ZF(irseg_svd)
         Q(QRSEG_XF_L())  =  FRSEG_XF(irseg_svd)
         Q(QRSEG_YF_L())  =  FRSEG_YF(irseg_svd)
         Q(QRSEG_TXF_L()) = FRSEG_TXF(irseg_svd)
         Q(QRSEG_TYF_L()) = FRSEG_TYF(irseg_svd)
         Q(QRSEG_PF_L())  = qp_est      
         DO i=1,NRSEG_CVF
            Q(QRSEG_CVF_L(i))= FRSEG_CVF(i,irseg_svd)
         ENDDO
         Q(QRSEG_TIME_L())=  FRSEG_TIME(rseg_ir)  ! ?????????????
         Q(QRSEG_DTIM_L())=  FRSEG_DTIM(rseg_ir)  ! ?????????????
         Q(QRSEG_ZE_L())  =  FRSEG_ZE(rseg_ir)
         Q(QRSEG_XE_L())  =  FRSEG_XE(rseg_ir)
         Q(QRSEG_YE_L())  =  FRSEG_YE(rseg_ir)
         Q(QRSEG_TXE_L()) = FRSEG_TXE(rseg_ir)
         Q(QRSEG_TYE_L()) = FRSEG_TYE(rseg_ir)
         Q(QRSEG_PE_L())  = qp_est
         DO i=1,NRSEG_CVE
            Q(QRSEG_CVE_L(i))= FRSEG_CVE(i,rseg_ir)
         ENDDO
         Q(QRSEG_CHI_L()) = FRSEG_CHI(rseg_ir)+FRSEG_CHI(irseg_svd)
         IQ(IQRSEG_FIT_L()) = 2 ! With Momentum information
         IQ(IQRSEG_CMP_L()) = IOR(IRSEG_CMP(rseg_ir),
     $                            IRSEG_CMP(irseg_svd))
   
c ---- Setup MMREL RSEG <-> HITB
   
         DO i=1,2
            IF(i.EQ.1) THEN
               indx = PRSEG_HITB(irseg_svd)
            ELSE    
               indx = PRSEG_HITB(rseg_ir)
            ENDIF
            DO WHILE(indx.NE.0)
               ihitb = MRSEG_HITB(indx)
               CALL MMBREL(JRSHI,irseg_new,ihitb)
               indx=XRSEG_HITB(indx)
            ENDDO
         ENDDO
   
c ---- Setup MMREL RSEG <-> RTRA
   
c         Nothing to be done now
   
c ---- Setup MMREL RSEG <-> RPNT
   
         DO i=1,2
            IF(i.EQ.1) THEN
               indx = PRSEG_RPNT(irseg_svd)
            ELSE    
               indx = PRSEG_RPNT(rseg_ir)
            ENDIF
            DO WHILE(indx.NE.0)
               irpnt = MRSEG_RPNT(indx)
               CALL MMBREL(JRSRP,irseg_new,irpnt)
               indx=XRSEG_RPNT(indx)
            ENDDO
         ENDDO
   
c ----    Setup MMREL RSEG <-> MTRA if it is unambigous
   
         imtra=0
         DO i=1,2
            IF(i.EQ.1) THEN
               indx = PRSEG_MTRA(irseg_svd)
            ELSE    
               indx = PRSEG_MTRA(rseg_ir)
            ENDIF
            DO WHILE(indx.NE.0)
               IF(imtra.EQ.0) THEN
                  imtra=MRSEG_MTRA(indx)
               ELSE
                  IF(imtra.NE.MRSEG_MTRA(indx)) THEN
                     imtra=0
                     GOTO 900
                  ENDIF   
               ENDIF
               indx=XRSEG_MTRA(indx)
            ENDDO
         ENDDO

 900     CONTINUE

         IF(imtra.NE.0) CALL MMBREL(JRSMT,irseg_new,imtra)


c c ----    Setup MMREL RSEG <-> MTRA (Doesn't check for double counting yet)
c    
c          DO i=1,2
c             IF(i.EQ.1) THEN
c                indx = PRSEG_MTRA(irseg_svd)
c             ELSE    
c                indx = PRSEG_MTRA(rseg_ir)
c             ENDIF
c             DO WHILE(indx.NE.0)
c                imtra = MRSEG_MTRA(indx)
c                CALL MMBREL(JRSMT,irseg_new,imtra)
c                indx=XRSEG_MTRA(indx)
c             ENDDO
c          ENDDO
c    
c ----    Setup MMREL RSEG <-> RHIT
c ----    First find all RHITs we need
   
         nrhits=0
   
         DO i=1,2
            IF(i.EQ.1) THEN
               indx = PRSEG_RHIT(irseg_svd)
            ELSE    
               indx = PRSEG_RHIT(rseg_ir)
            ENDIF
            DO WHILE(indx.NE.0)
               IF(nrhits.LT.nrhits_max) nrhits=nrhits+1
               rhit_ir(nrhits)=MRSEG_RHIT(indx)
               indx=XRSEG_RHIT(indx)
            ENDDO
         ENDDO
   
         DO i=nrhits,1,-1
   
c ---    As rseg <-> rhit is only a many-to-one relation, we have to create
c        a new RHIT
   
            CALL MMBOOK(JRHIT,1)
            irhit_new=NRHIT()
            irhit=rhit_ir(i)
   
            Q(QRHIT_X_L())     =FRHIT_X(irhit)
            Q(QRHIT_Y_L())     =FRHIT_Y(irhit)
            Q(QRHIT_TX_L())    =FRHIT_TX(irhit)
            Q(QRHIT_TY_L())    =FRHIT_TY(irhit)
            Q(QRHIT_P_L())     =qp_est
            Q(QRHIT_Q_L())     =FRHIT_Q(irhit)
            IQ(IQRHIT_RTRA_L())=IRHIT_RTRA(irhit)
            ihitb = ORHIT_HITB(irhit)
            CALL MMBREL(JHIRH,ihitb,irhit_new)     ! relation HITB <-  RHIT
   
            CALL MMBREL(JRSRH,irseg_new,irhit_new) ! relation RSEG <-> RHIT
         ENDDO
   
         IF(nrhits.EQ.nrhits_max.AND.ma_verblvl.GE.5)
     $        WRITE(*,*) ' matchsvd: nrhits = nrhits_max !!'

c --- Find next (matching) SVD segment

c         CALL mafisvds98(irseg_svd,rseg_ir)
         CALL ma98fisvds(irseg_svd,rseg_ir,rseg_last)

      ENDDO
c -------------------------------------------------------------------------
      
      IF(ma_verblvl.GE.11)
     $     WRITE(*,*) ,' matchsvd:',
     $   'Count of SVD segments matched for this OTR RSEG  =',match_cnt
      CALL HF1(mahb_match,match_cnt,1.)

      END
**************************************************************************
*  End of matchsvd
**************************************************************************





