c Modified by Jenny Ivarsson for semileptonic c decays

      subroutine matulocCsem()

*     **** locate B & its lepton daughter(s) & store into /zpstat/
      implicit none
#include "arte/Arte.fi"

#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/MVER.fi"
#include "auto/TOPP.fi"

#include "mapstat.fi"
#include "pris/zmh.fi"
      INTEGER iw,i,pstat_nC
      integer mc_c, mc_lplus, mc_lminus,
     +    mc_other, mc, vert, ndaught, ii, tpname, jj
      real charge, mass
      integer code_d0, code_d0b, code_jpsi, code_eplus,
     +     code_eminus, code_muplus, code_muminus, 
     +     code_ds2star,code_clam, code_bclam
      character*20 cname
      logical init



      data init /.false./
      save init, code_d0, code_d0b, code_jpsi,  code_eplus,code_bclam,
     +     code_eminus, code_muplus, code_muminus,code_ds2star,code_clam

#include "arte/Arte.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/MVER.ff"
#include "auto/TOPP.ff"

      IF (.not.init) THEN
         code_d0      = tpname('D.')
         code_d0b     = tpname('D~')
         code_ds2star = tpname('D_s2*-')
         code_clam    = tpname('Lam_c+')
         code_bclam   = tpname('Lam_c-')
         code_jpsi    = tpname('Jpsi')
         code_eplus   = tpname('e+')
         code_eminus  = tpname('e-')
         code_muplus  = tpname('mu+')
         code_muminus = tpname('mu-')
         init = .true.
      ENDIF


*     **** clear golden B buffer / set golden decays first
c     It's done in matuloclep !
c      ma_pstat_n = 0

*     **** loop over MC buffer, find JPsi
      DO mc_C=1,NMTRA()
c         not_counted=.TRUE.
c         WRITE(*,*) ' matulocBsem 1:',
c     $           ma_pstat_n,i,mc_B,ma_pstat(5,i),not_counted
c          DO i=1,ma_pstat_n
c c            WRITE(*,*) ' matulocBsem 2:',
c c     $           ma_pstat_n,i,mc_B,ma_pstat(5,i),not_counted
c             IF(mc_B.EQ.ma_pstat(5,i))THEN ! avoid double counting
c                not_counted=.FALSE.
c             ENDIF
c c            WRITE(*,*) ' matulocBsem 3:',
c c     $           ma_pstat_n,i,mc_B,ma_pstat(5,i),not_counted
c          ENDDO

         if ((omtra_topp(mc_c).GE.code_d0.AND.
     +        omtra_topp(mc_c).LE.code_ds2star).OR.
     $        omtra_topp(mc_c).eq.code_clam.OR.
     +        omtra_topp(mc_c).eq.code_bclam) then

         
*          **** look for daughters
           ndaught = 0
           mc_lplus = 0
           mc_lminus = 0
           mc_other = 0
         
*          **** search for B daughter particles
           WRITE(*,'(A,3a4,a,i4,a,i4)')' matulocBsem    B    =',
     &          (HTOPP_NAME(iw,OMTRA_TOPP(mc_c)),iw=1,NTOPP_NAME),
     &          'mc= ',mc_c,', bver=', OMTRX_BVER(mc_c)
           DO mc=mc_c+1,NMTRA()
             IF(omtrx_btra(mc).eq.mc_c) THEN
                ndaught = ndaught + 1
                WRITE(*,'(A,3a4,a,i4,a,i4)')' matulocBsem daughter=',
     &               (HTOPP_NAME(iw,OMTRA_TOPP(mc)),iw=1,NTOPP_NAME),
     &               'mc= ',mc,', bver=', OMTRX_BVER(mc)
                IF (omtra_topp(mc).eq.code_eplus
     +            .or.omtra_topp(mc).eq.code_muplus) THEN
                   mc_lplus = mc
                   WRITE(*,*) '             (got lep+)'
                ELSEIF (omtra_topp(mc).eq.code_eminus
     +               .or.omtra_topp(mc).eq.code_muminus) THEN
                   mc_lminus = mc
                   WRITE(*,*) '             (got lep-)'
                ELSE
                   mc_other = mc
                ENDIF
             ENDIF
           ENDDO
 70        CONTINUE            ! JPSI daughters
         
           IF (mc_lplus.EQ.0.AND.mc_lminus.EQ.0) go to 800
         
*          **** JPSI -> (l+l-) decay found!
           IF (ma_pstat_n.lt.ma_pstatmax) THEN
              ma_pstat_n = ma_pstat_n + 1
              ma_pstat(pstat_lplus  ,ma_pstat_n) = mc_lplus
              ma_pstat(pstat_lminus ,ma_pstat_n) = mc_lminus
              ma_pstat(pstat_piplus ,ma_pstat_n) = 0
              ma_pstat(pstat_piminus,ma_pstat_n) = 0
              ma_pstat(pstat_JPsi   ,ma_pstat_n) = 0
              ma_pstat(pstat_K0s    ,ma_pstat_n) = 0
              ma_pstat(pstat_B0     ,ma_pstat_n) = mc_c
         
           ELSE
              print *,' matulocBsem: overflow '
           ENDIF
         ENDIF                  ! B0's
 800     CONTINUE
      ENDDO
 900  CONTINUE                  ! mc loop

      end








