**-- Author :    Rainer Mankel   19/05/95
**-- modified: Peter Weyers
      subroutine matulocb()

*     **** locate golden Bs & their daughters & store into /zpstat/
      implicit none
#include "arte/Arte.fi"

#include "mapstat.fi"
c #include "pris/zmh.fi"
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/MVER.fi"
#include "auto/TOPP.fi"
      integer pstat_nB0,i
      logical not_counted

      integer mc_b, mc_k0s, mc_lplus, mc_lminus, mc_piplus, mc_piminus,
     +    mc_jpsi, mc_other, mc, ndaught, tpname
      integer code_b0, code_b0b, code_jpsi, code_k0s, code_eplus,
     +     code_eminus, code_muplus, code_muminus, code_piplus,
     +     code_piminus,code_bc2starp,code_lamb,code_lamb_b

      logical init

      data init /.false./
      save init, code_b0, code_b0b, code_jpsi, code_k0s, code_eplus,
     +     code_eminus, code_muplus, code_muminus, code_piplus,
     +     code_piminus,code_bc2starp,code_lamb,code_lamb_b
#include "arte/Arte.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/MVER.ff"
#include "auto/TOPP.ff"

      if (.not.init) then
         code_b0      = tpname('B.')
         code_b0b     = tpname('B~')
         code_bc2starp= tpname('B_c2*+')
         code_lamb    = tpname('Lam_b.')
         code_lamb_b  = tpname('Lam_b.~')
         code_jpsi    = tpname('Jpsi')
         code_k0s     = tpname('K_S')
         code_eplus   = tpname('e+')
         code_eminus  = tpname('e-')
         code_muplus  = tpname('mu+')
         code_muminus = tpname('mu-')
         code_piplus  = tpname('pi+')
         code_piminus = tpname('pi-')
         init = .true.
      endif

*     **** clear golden B buffer
c     It's done in matuloclep !
c      ma_pstat_n = 0
      pstat_nB0=ma_pstat_n

*     **** loop over MC buffer, find B
      do 10 mc_b=1,NMTRA()
         not_counted=.TRUE.
c         WRITE(*,*) ' matulocJPsi.F 1:',
c     $           pstat_nB,i,mc_JPsi,ma_pstat(5,i),not_counted
         DO i=1,pstat_nB0
c            WRITE(*,*) ' matulocJPsi.F 2:',
c     $           pstat_nB0,i,mc_JPsi,ma_pstat(5,i),not_counted
            IF(mc_b.EQ.ma_pstat(pstat_B0,i))THEN ! avoid double counting
               not_counted=.FALSE.
            ENDIF
c            WRITE(*,*) ' matulocJPsi.F 3:',
c     $           pstat_nB0,i,mc_JPsi,ma_pstat(5,i),not_counted
         ENDDO
         IF (not_counted) THEN

          if ((omtra_topp(mc_b).GE.code_b0.AND.
     +         omtra_topp(mc_b).LE.code_bc2starp).OR.
     $         omtra_topp(mc_b).eq.code_lamb.OR.
     $         omtra_topp(mc_b).EQ.code_lamb_b) then
*            **** look for daughters
             ndaught = 0
             mc_jpsi = 0
             mc_k0s = 0
             mc_other = 0
 
*            **** search for B daughter particles
             do 30 mc=mc_b+1,iq(jmtra+2)
                if (omtrx_btra(mc).eq.mc_b) then
                   ndaught = ndaught + 1
                   if (omtra_topp(mc).eq.code_jpsi) then
                      mc_jpsi = mc
                   elseif (omtra_topp(mc).eq.code_k0s) then
                      mc_k0s = mc
                   else
                      mc_other = mc
                   endif
                endif
 30          continue           ! b daughters
 
             if (mc_jpsi.eq.0) go to 10 ! reject other B decays
 
*            **** check J/Psi
             ndaught = 0
             mc_lplus = 0
             mc_lminus = 0
             mc_other = 0
*            **** search for J/Psi daughter particles
             do 50 mc=mc_jpsi+1,iq(jmtra+2)
                if (omtrx_btra(mc).eq.mc_jpsi) then
                   ndaught = ndaught + 1
                   if (omtra_topp(mc).eq.code_eplus
     +                  .or.omtra_topp(mc).eq.code_muplus) then
                      mc_lplus = mc
                   elseif (omtra_topp(mc).eq.code_eminus
     +                     .or.omtra_topp(mc).eq.code_muminus) then
                      mc_lminus = mc
                   else
                      mc_other = mc
                   endif
                endif
 50          continue           ! J/Psi daughters
 
             if (ndaught.ne.2.or.mc_lplus.eq.0 ! reject other J/Psi decs
     +            .or.mc_lminus.eq.0.or.mc_other.ne.0) go to 10
             
*            **** check K0S
             IF(mc_k0s.NE.0) THEN
                ndaught = 0
                mc_piplus = 0
                mc_piminus = 0
                mc_other = 0
*            **** search for K0S daughter particles
                do 70 mc=mc_k0s+1,iq(jmtra+2)
                   if (omtrx_btra(mc).eq.mc_k0s) then
                      ndaught = ndaught + 1
                      if (omtra_topp(mc).eq.code_piplus) then
                         mc_piplus = mc
                      elseif (omtra_topp(mc).eq.code_piminus) then
                         mc_piminus = mc
                      else
                         mc_other = mc
                      endif
                   endif
 70             continue        ! K0S daughters
             ENDIF
 
*            **** B -> J/Psi K0S -> (l+l-)(pi+pi-) decay found!
             if (ma_pstat_n.lt.ma_pstatmax) then
                ma_pstat_n = ma_pstat_n + 1
                ma_pstat(pstat_lplus  ,ma_pstat_n) = mc_lplus
                ma_pstat(pstat_lminus ,ma_pstat_n) = mc_lminus
                ma_pstat(pstat_piplus ,ma_pstat_n) = mc_piplus
                ma_pstat(pstat_piminus,ma_pstat_n) = mc_piminus
                ma_pstat(pstat_JPsi   ,ma_pstat_n) = mc_jpsi
                ma_pstat(pstat_K0s    ,ma_pstat_n) = mc_k0s
                ma_pstat(pstat_B0     ,ma_pstat_n) = mc_b
 
             else
                print *,' matulocb: golden B overflow '
             endif
          endif                  ! Bs
         endif
 10   continue                  ! mc loop

      end




