*-- Author :    Rainer Mankel   19/05/95

      subroutine matulocgol()

*     **** locate golden B0s & their daughters & store into /zpstat/
      implicit none
#include "arte/Arte.fi"

#include "match98.fi"
#include "mapstat.fi"
c #include "pris/zmh.fi"
      integer mc_b, mc_k0s, mc_lplus, mc_lminus, mc_piplus, mc_piminus,
     +    mc_jpsi, mc_other, mc, ndaught, tpname
      integer code_b0, code_b0b, code_k0s, code_piplus,
     +     code_piminus
c      +     , code_jpsi, code_eplus,
c      +     code_eminus, code_muplus, code_muminus

      logical init
#include "auto/MTRA.fi"
#include "auto/MTRX.fi"
#include "auto/MVER.fi"
#include "auto/TOPP.fi"
      data init /.false./
      save init, code_b0, code_b0b, code_k0s, code_piplus,
     +     code_piminus
c     +     , code_jpsi, code_eplus,
c     +     code_eminus, code_muplus, code_muminus
#include "arte/Arte.ff"
#include "auto/MTRA.ff"
#include "auto/MTRX.ff"
#include "auto/MVER.ff"
#include "auto/TOPP.ff"

      if (.not.init) then
         code_b0      = tpname('B.')
         code_b0b     = tpname('B~')
c         code_jpsi    = tpname('Jpsi')
         code_k0s     = tpname('K_S')
c         code_eplus   = tpname('e+')
c         code_eminus  = tpname('e-')
c         code_muplus  = tpname('mu+')
c         code_muminus = tpname('mu-')
         code_piplus  = tpname('pi+')
         code_piminus = tpname('pi-')
         init = .true.
      endif


      IF(ma_verblvl.GE.20)
     $     WRITE(*,*) ' matulocgol: starting'
*     **** clear golden B buffer
c     It's done in matuloclep !
c      ma_pstat_n = 0

*     **** loop over MC buffer, find B0, B0=
      do 10 mc_b=1,iq(jmtra+2)
         if (omtra_topp(mc_b).eq.code_b0
     +        .or.omtra_topp(mc_b).eq.code_b0b) then
*           **** look for daughters
            ndaught = 0
            mc_jpsi = 0
            mc_k0s = 0
            mc_other = 0

*           **** search for B0 daughter particles
            do 30 mc=mc_b+1,iq(jmtra+2)
               if (omtrx_btra(mc).eq.mc_b) then
                  ndaught = ndaught + 1
                  if (omtra_topp(mc).eq.code_jpsi) then
                     mc_jpsi = mc
                  elseif (omtra_topp(mc).eq.code_k0s) then
                     mc_k0s = mc
                  else
                     mc_other = mc
                  endif
               endif
 30         continue            ! b0 daughters

            if (ndaught.ne.2.or.mc_jpsi.eq.0 ! reject other B0 decays
     +           .or.mc_k0s.eq.0.or.mc_other.ne.0) go to 10

*           **** check J/Psi
            ndaught = 0
            mc_lplus = 0
            mc_lminus = 0
            mc_other = 0
*           **** search for J/Psi daughter particles
            do 50 mc=mc_jpsi+1,iq(jmtra+2)
               if (omtrx_btra(mc).eq.mc_jpsi) then
                  ndaught = ndaught + 1
                  if (omtra_topp(mc).eq.code_eplus
     +                 .or.omtra_topp(mc).eq.code_muplus) then
                     mc_lplus = mc
                  elseif (omtra_topp(mc).eq.code_eminus
     +                    .or.omtra_topp(mc).eq.code_muminus) then
                     mc_lminus = mc
                  else
                     mc_other = mc
                  endif
               endif
 50         continue            ! J/Psi daughters

            if (ndaught.ne.2.or.mc_lplus.eq.0 ! reject other J/Psi decs
     +           .or.mc_lminus.eq.0.or.mc_other.ne.0) go to 10

*           **** check K0S
            ndaught = 0
            mc_piplus = 0
            mc_piminus = 0
            mc_other = 0
*           **** search for K0S daughter particles
            do 70 mc=mc_k0s+1,iq(jmtra+2)
               if (omtrx_btra(mc).eq.mc_k0s) then
                  ndaught = ndaught + 1
                  if (omtra_topp(mc).eq.code_piplus) then
                     mc_piplus = mc
                  elseif (omtra_topp(mc).eq.code_piminus) then
                     mc_piminus = mc
                  else
                     mc_other = mc
                  endif
               endif
 70         continue            ! K0S daughters

            if (ndaught.ne.2.or.mc_piplus.eq.0 ! reject other K0S decays
     +           .or.mc_piminus.eq.0.or.mc_other.ne.0) go to 10

*           **** B0 -> J/Psi K0S -> (l+l-)(pi+pi-) decay found!
            if (ma_pstat_n.lt.ma_pstatmax) then
               ma_pstat_n = ma_pstat_n + 1
               ma_pstat(pstat_lplus  ,ma_pstat_n) = mc_lplus
               ma_pstat(pstat_lminus ,ma_pstat_n) = mc_lminus
               ma_pstat(pstat_piplus ,ma_pstat_n) = mc_piplus
               ma_pstat(pstat_piminus,ma_pstat_n) = mc_piminus
               ma_pstat(pstat_JPsi   ,ma_pstat_n) = mc_jpsi
               ma_pstat(pstat_K0s    ,ma_pstat_n) = mc_k0s
               ma_pstat(pstat_B0     ,ma_pstat_n) = mc_b

c               gold_mh(mc_lplus) = .true.
c               gold_mh(mc_lminus) = .true.
c               gold_mh(mc_piplus) = .true.
c               gold_mh(mc_piminus) = .true.
c
c               gold_mh(mc_jpsi) = .true.
c               gold_mh(mc_k0s) = .true.
c               gold_mh(mc_b) = .true.

            else
               IF(ma_verblvl.GE.4)
     $              print *,' matulocgol: golden B overflow '
            endif
         endif                  ! B0s
 10   continue                  ! mc loop

      end



