      SUBROUTINE MAVXRTRA(rsegc,rsegs,gtar_ir)

      IMPLICIT NONE

************************************************************************
*     Author     : Peter J. Weyers <weyers@ifh.de>
*     Description: Routine to match given RSEGs with Vertex Detector RSEGs
*                  by matchsvd() and to create refitted RTRA by tfrfseg().
      INTEGER rsegc        ! in   Number of RSEGs in rsegs()
      INTEGER rsegs(rsegc) ! in   Array of RSEG Table Row numbers of segments
*                          !      to be matched
      INTEGER gtar_ir      ! in   GTAR Row number of target Wire to be used for
*                          !      Target Constraint in matchsvd()  
************************************************************************


#include "arte/Arte.fi"
#include "auto/RSEG.fi"
#include "auto/RTRA.fi"
#include "auto/RTRX.fi"
#include "auto/TOPP.fi"
c #include "mapstat.fi"
#include "match98.fi"
#include "matarx.fi"
      INTEGER imtra_rseg ! MC track related to the RSEG (for statistical use)
      REAL    qp_fit     ! q/p fitted by tfrfseg

c -- flags
      INTEGER ierror
      LOGICAL retval
c -- counter etc.

      INTEGER plus,minus      !   counting variables for mu track array
      INTEGER ima             !   entry of seg_ma

      INTEGER rseg_ir       !          
      INTEGER rseg_i
      INTEGER i       !
c      INTEGER irseg           !
      INTEGER irtra_new       !
      INTEGER old_ntra        ! previous number of 
      INTEGER ngold           !
      INTEGER ma_seg_taken     ! counts of OTR segments taken 
      CHARACTER*10 maokstr    ! Used for diagnostic output

#include "arte/Arte.ff"
#include "auto/RSEG.ff"
#include "auto/RTRA.ff"
#include "auto/RTRX.ff"
#include "auto/TOPP.ff"


************************************************************************


c ---- Do the Matching  -----------------------------------------------------

      ma_n=0 ! will be changed by matchsvd

c         CALL matuloclep()
c         ngold=1
c         CALL magettar(ngold,ierror)

      IF(gtar_ir.GE.0) THEN
         CALL masettarx(gtar_ir,ierror)
         IF(ierror.NE.0) THEN
            IF(ma_verblvl.GE.2)
     $           WRITE(*,*) ' mavxrtra: masettarx returned error',ierror
         ENDIF
      ELSE
         IF(ma_verblvl.GE.6) WRITE(*,*) ' mavxrtra:',
     $        'masettarx not called, gtar_ir=',gtar_ir
      ENDIF

      IF(rsegc.EQ.0) THEN
c          DO rseg_ir=1,NRSEG()
c             IF(IRSEG_CMP(rseg_ir).EQ.RSEGc_patt) THEN
c                ma_seg_taken=ma_seg_taken+1
c                IF(PRSEG_MTRA(rseg_ir).NE.0) THEN
c                   IF(XRSEG_MTRA(PRSEG_MTRA(rseg_ir)).EQ.0) THEN
c                      imtra_rseg=MRSEG_MTRA(PRSEG_MTRA(rseg_ir))
c                   ELSE
c                      imtra_rseg=0
c                   ENDIF
c                ELSE
c                   imtra_rseg=0
c                ENDIF
c    
c c ---- count possible matches
c                IF(imtra_rseg.NE.0) THEN
c                   DO i=1,NRSEG()
c                      IF(IRSEG_CMP(i).EQ.RSEGc_vxd) THEN
c                         CALL maifrsegmtra(i,imtra_rseg,retval)
c                         IF(retval) THEN
c                            match_poss_cnt=match_poss_cnt+1
c                         ENDIF
c                      ENDIF
c                   ENDDO
c                ENDIF
c c ---------------------------
c 
c                CALL matchsvd(rseg_ir,imtra_rseg,ierror)
c       
c                IF(ierror.NE.0) THEN 
c                   WRITE(*,*) ' mavxrtra: matchsvd returned error ',
c      $                 ierror
c                ENDIF
c             ENDIF
c c ---- select next segment
c          ENDDO
         IF(ma_verblvl.GE.1)
     $        WRITE(*,*) ' mavxrtra: rseg count = 0 => nothing to do'
      ELSE
         DO rseg_i=1,rsegc
            rseg_ir=rsegs(rseg_i)
            IF(PRSEG_MTRA(rseg_ir).NE.0) THEN
               IF(XRSEG_MTRA(PRSEG_MTRA(rseg_ir)).EQ.0) THEN
                  imtra_rseg=MRSEG_MTRA(PRSEG_MTRA(rseg_ir))
               ELSE
                  imtra_rseg=0 ! MTRA relation for RSEG ambigous
               ENDIF
            ELSE
               imtra_rseg=0 ! no MTRA relations for RSEG
            ENDIF
            
c ---- count possible matches
            IF(imtra_rseg.NE.0) THEN
               DO i=1,NRSEG()
                  IF(IRSEG_CMP(i).EQ.RSEGc_vxd) THEN
                     ma_verblvl=ma_verblvl-10 ! Oh-Ohhh, be careful, Peter!
                     CALL maifrsegmtra(i,imtra_rseg,retval)
                     ma_verblvl=ma_verblvl+10 ! Don't forget this!
                     IF(retval) THEN
                        match_poss_cnt=match_poss_cnt+1
                     ENDIF
                  ENDIF
               ENDDO
            ENDIF
c ------------------------
            
            match_try_cnt=match_try_cnt+1
            CALL matchsvd(rseg_ir,imtra_rseg,ierror)
            
            IF(ierror.NE.0.AND.ma_verblvl.GE.2) THEN 
               WRITE(*,*) ' mavxrtra: matchsvd returned error ',
     $              ierror
            ENDIF
c ---- select next segment
         ENDDO
      ENDIF
c ---- Do the Refit -----------------------------------------------------

      lplus_n  = 0
      lminus_n = 0

      DO ima=1,ma_n
            old_ntra=NRTRA()
            CALL TFRFSEG(ma_rsegm(ima),0,ierror)
            IF(old_ntra.LT.NRTRA()) THEN
               irtra_new=NRTRA()
               IF(ierror.LT.0) THEN
                  IF(ma_verblvl.GE.5)
     $                 WRITE(*,*) ' mavxrtra: tfrfseg ierror=',ierror
                  ma_tfrfsegerrcnt=ma_tfrfsegerrcnt+1
               ENDIF
               qp_fit=FRTRA_PF(irtra_new)

c --- Decide on charge sign by kurvature and remember RTRA row numbers 

               IF(qp_fit.LE.0) THEN
                  lminus_n=lminus_n+1
                  IF(lminus_n.LE.max_lep) THEN
                     lminus_rtra(lminus_n)=irtra_new
                  ELSE
                     IF(ma_verblvl.GE.5)
     $                    WRITE(*,*) ' !!! lminus_n reached max_lep!'
                  ENDIF
               ELSE
                  lplus_n=lplus_n+1
                  IF(lplus_n.LE.max_lep) THEN
                     lplus_rtra(lplus_n)=irtra_new
                  ELSE
                     IF(ma_verblvl.GE.5)
     $                    WRITE(*,*) ' !!! lplus_n reached max_lep!'
                  ENDIF
               ENDIF ! charge sign
               ma_tfrfsegsucccnt=ma_tfrfsegsucccnt+1
            ELSE
               IF(ma_verblvl.GE.5)
     $              WRITE(*,*) ' mavxrtra: tfrseg failed! <---'
               ma_tfrfsegfailcnt=ma_tfrfsegfailcnt+1
               irtra_new=0
            ENDIF ! tfrfseg error
            ma_rtra(ima)=irtra_new
      ENDDO ! ima

c ---- Output Counters


      IF(ma_verblvl.GE.11) THEN
         WRITE(*,*) ' mavxrtra: Matching Results:'
         DO ima=1,ma_n
            IF(ma_ok(ima).EQ.ma_gic_true) THEN
               maokstr=' (ok)'
            ELSEIF(ma_ok(ima).EQ.ma_gic_false) THEN
               maokstr=' (ghost)'
            ELSE
               maokstr=' (?)'
            ENDIF   
            WRITE(*,'(''          '',I4,A,I4,I4,A,I4,A9,A,I5)')
     $           ima,'.  RSEGs',ma_rseg1(ima),ma_rseg2(ima),
     $           '  combined to',ma_rsegm(ima),maokstr,
     $           ' RTRA:',ma_rtra(ima)
         ENDDO
      ENDIF
      IF(ma_verblvl.GE.6.AND.ma_n.EQ.0) WRITE(*,*) ' mavxrtra:',
     $        ' No Matches found'


 900  END

************************************************************************
* End of MAVXRTRA
************************************************************************





